macroScript SkinTools_Env category:"RPManager" 
ButtonText:"SkinTools_Env 2.0"
tooltip:"SkinTools_Env 2.0"
(
 /*
skin tools:envelopes
useful for modifying multiple cross sections at a time - also for reversing a bone's cross sections after copying
to the other side of your character

thrown together by grant adam   ghra@optushome.com.au
published as part of the RPManager toolkit - www.rpmanager.com

You need to have the skin modifier active in the modify panel. Subobject mode is necessary for affecting selected bones,
but othwise modify all and modify by named selection/selected items still works.

version 2.0 - many UI changes, new features. If you like the changes thank Paul Hormis (and me).
			- new rotate bone 
			- new move bone ends in different axes
			- dockable
			- replace bone
			- little used stuff move to menus
			- compact floaters for optimised workflow
			- toggle SO mode on off (just for convenience)

version 1_49 - added a apply skin rollout.
version 1.48 - fixed changed selection handling
version 1.47 - changed selection handling
version 1.46 - bug fix
version 1.45 - percent mode in addition to relative and absolute
version 1.43 - now a dialog, remembers pos/size
version 1.42 - bug fix
version 1.41 - works around a selectionsets bug in max
version 1.4 - modify env ends update attempt
version 1.3 - fixed the slow open/close
version 1.2 - added button to change the crossection spinners to modifying envelope end positions (re: d.stinnett)
version 1.1 - copy and paste multiple, mirror multiple (fixed not mirroring added crossections problem)
version 1.01 - cosmetic fixes
version 1.0 - implemented undo for some operations, also sync'd the first selections in the two bone lists
versino 0.99 - various optimisations
version 0.97 - added display of envelopes of selected bones in list (thanks peter!)
version 0.96 - realised I was appending my original value arrays continously which could have eaten memory and crashed - fixed so commented some gc's
version 0.95 - hitting Absolute mode and then typing 0 would fail to change - fixed
version 0.9 - everything seems to work...
version 0.7 - relevant named selections selecting in list of bones in skin
version 0.6 - relevant named selection list
*/

try(
	destroydialog subRoll
	)catch(try(cui.UnRegisterDialogBar subRoll;	destroydialog subRoll)catch(print"error1"))
global skintoolsenv, dsply, lck, subroll
global skinToolsFloater
global STlastSelected
rollout selectedBoneFloater "Selected Bone" width:190 height:350
(
	-- some functions
	fn getSelVertWeight =
	(	if selection[1] == undefined do return()
		if (modpanel.getCurrentObject()) == undefined do return()
		skin_index = modPanel.getModifierIndex selection[1] (modpanel.getCurrentObject())
		if skin_index == undefined do return()
		skinActive = selection[1].modifiers [skin_index]
		if classof skinActive != skin do return()
		numVerts = skinOps.GetNumberVertices skinActive 
		selVerts = for i in 1 to numVerts where skinOps.IsVertexSelected skinActive  i == 1 collect i
		if selVerts.count != 1 do return(#indeterminate)
		whichBone = skinOps.GetSelectedBone skinActive 
		whichLocalBone = undefined
		numweights = skinOps.GetVertexWeightCount skinActive selverts[1]
		for i in 1 to numweights do
		(
			if (skinOps.GetVertexWeightBoneID skinActive selVerts[1] i) == whichBone do 
			(	
				whichLocalBone = i
				exit
			)
		)
		if whichLocalBone == undefined do return 0.0
		return skinOps.GetVertexWeight skinActive selverts[1] whichLocalBone 
	)
	fn setSelVertWeight val =
	(
		skin_index = modPanel.getModifierIndex selection[1] (modpanel.getCurrentObject())
		skinActive = selection[1].modifiers [skin_index]
		if classof skinActive != skin do return()
		numVerts = skinOps.GetNumberVertices skinActive 
		selVerts = for i in 1 to numVerts where skinOps.IsVertexSelected skinActive  i == 1 collect i
		whichBone = skinOps.GetSelectedBone skinActive
		with redraw off
		(
			for i in selVerts do 
				skinOps.SetVertexWeights skinActive i whichBone val
		)
	)

	checkbutton envOrCrs "CrossSections" pos:[5,32] width:76 height:21 highlightColor:(color 140 140 255)
	checkbutton lockMove "L" pos:[84,32] width:13 height:21 enabled:false highlightColor:(color 140 140 255)
	
	GroupBox grp1 "Selected Bone" pos:[4,97] width:180 height:153
	spinner outSel_a "" pos:[92,116] width:43 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	checkbutton RelO_a "R" pos:[141,137] width:12 height:15 highlightColor:(color 200 255 200) checked:true
	checkbutton absO_a "A" pos:[154,137] width:11 height:15 highlightColor:(color 200 200 255) 
	checkbutton percO_a "%" pos:[166,137] width:12 height:15 highlightColor:(color 255 128 128) 
	checkbutton percOM "%" pos:[166,137] width:12 height:15 highlightColor:(color 255 128 128) visible:false 
	checkbutton Rel_a "R" pos:[141,204] width:12 height:15 highlightColor:(color 200 255 200) checked:true 
	checkbutton abs_a "A" pos:[154,204] width:11 height:15 highlightColor:(color 200 200 255) 
	checkbutton perc_a "%" pos:[166,204] width:12 height:15 highlightColor:(color 255 128 128) 
	checkbutton percM "%" pos:[166,204] width:12 height:15 highlightColor:(color 255 128 128) visible:false 
	spinner insel_a "" pos:[90,184] width:45 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	button getsel "Rebuild Selection Sets/Bones" pos:[5,325] width:180 height:22
	GroupBox grp5 "Move Ends Axis" pos:[4,58] width:180 height:37
	radiobuttons rdo1 "" pos:[13,74] width:187 height:16 enabled:false labels:#("Long", "Other1", "Other2") columns:3
	
	label Soutsel "Start" pos:[57,117] height:14
	label Ioutsel "Inner" pos:[57,137] height:14
	label Eoutsel "End" pos:[57,157] height:14
	
	label Sinsel "Start" pos:[57,185] height:14 
	label Iinsel "Inner" pos:[57,205] height:14
	label Einsel "End" pos:[57,225] height:14 	
	checkbutton SoutselC "L" pos:[38,116] width:17 height:14 checked:false
	checkbutton IoutselC "L" pos:[38,136] width:17 height:14 checked:false
	checkbutton EoutselC "L" pos:[38,156] width:17 height:14 checked:false
	
	checkbutton SinselC "L" pos:[38,186] width:17 height:14 checked:false
	checkbutton IinselC "L" pos:[38,205] width:17 height:14 checked:false
	checkbutton EinselC "L" pos:[38,224] width:17 height:14 checked:false


	checkbutton lockSel "L" pos:[17,170] width:16 height:21 highlightColor:(color 255 255 0)
	label sLabO "Outer" pos:[7,137] height:13
	label SelLabI "Inner" pos:[7,205] width:28 height:13
	label lbl23 "Rotate:" pos:[104,36] width:39 height:15
	button XY "X" pos:[140,33] width:14 height:21
	button YZ "Y" pos:[154,33] width:14 height:21
	button XZ "Z" pos:[168,33] width:14 height:21
	button togEdit "Toggle Edit Envelopes" pos:[4,5] width:180 height:21


	label sLabStart "Start of Envelope:" pos:[11,137] width:89 height:13 visible:false
	label SelLabEnd "End of Envelope:" pos:[11,205] width:89 height:13 visible:false

	spinner outSel_b "" pos:[92,136] width:43 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	spinner outSel_c "" pos:[92,156] width:43 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	spinner insel_b "" pos:[90,204] width:45 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	spinner insel_c "" pos:[90,224] width:45 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	button paintWeights "Toggle Paint Weights" pos:[9,294] width:124 height:22
	button paintSetup "..." pos:[137,294] width:41 height:22
	button updte "Update" pos:[136,268] width:43 height:22
	groupBox grp3 "Weighting" pos:[4,252] width:180 height:70
	spinner weightSpin "Abs. Effect:" pos:[21,271] fieldwidth:40 height:16 range:[0,1,0] scale:0.01
	
	on lockSel changed state do
	(
		skintoolsenv.lockSel.state = state
		skintoolsenv.lockSel.changed state
	)
	
	on lockmove changed state do
	(
		skintoolsenv.lockmove.state = state
		skintoolsenv.lockmove.changed state
		SelLabEnd.enabled = insel_b.enabled = not state
	)
	on rdo1 changed state do
	(
	skintoolsenv.rdo1.state = state
	skintoolsenv.rdo1.changed state
	)

	on envOrCrs changed state do
	(
		skintoolsenv.envOrCrs.state = state
		skintoolsenv.envOrCrs.changed state

---------------------------
			rdo1.enabled = envOrCrs.state
			XY.enabled = YZ.enabled = xz.enabled = not envOrCrs.state
			if state then 
			(
				lockMove.enabled = true
				insel_c.enabled = not lockMove.state
				envOrCrs.caption = "Env. Ends"
				abs_a.visible = rel_a.visible = perc_a.visible = \
				absO_a.visible = relO_a.visible = percO_a.visible =  false
			Soutsel.visible = Ioutsel.visible = Eoutsel.visible = \
			Sinsel.visible =Iinsel.visible =Einsel.visible = false
				percM.visible = \
				percOM.visible = true
				
				percM.state = skintoolsenv.percM.state
				percOM.state = skintoolsenv.percOM.state
				
			sLabO.visible =\
			SelLabI.visible = false
				
			sLabStart.visible =\
			SelLabEnd.visible = true
			
			lockSEl.visible = false
			
			outsel_b.pos.x += 15
			insel_b.pos.x += 15
			
			outsel_a.visible = outsel_c.visible = insel_a.visible = insel_c.visible = false
				outsel_a.value = 0
				insel_a.value = 0
				outsel_b.value = 0
				insel_b.value = 0
				outsel_c.value = 0
				insel_c.value = 0
				insel_b.enabled = not lockMove.state
			)
			else 
			( 
				lockMove.enabled = false
				insel_c.enabled = true
				envOrCrs.caption = "CrossSections"
				abs_a.visible = rel_a.visible = perc_a.visible = \
				absO_a.visible = relO_a.visible = percO_a.visible =  true
			Soutsel.visible = Ioutsel.visible = Eoutsel.visible = \
			Sinsel.visible =Iinsel.visible =Einsel.visible = true
		
				percM.visible = \
				percOM.visible = false
				
			sLabO.visible =\
			SelLabI.visible =true
			sLabStart.visible =\
			SelLabEnd.visible =false
			lockSEl.visible =true
			outsel_a.visible = outsel_c.visible = insel_a.visible = insel_c.visible = true
			outsel_a.enabled = outsel_b.enabled = outsel_c.enabled = insel_a.visible = true
			
			if locksel.state then
			(
				insel_a.enabled =insel_b.enabled =insel_c.enabled = false
				rel_a.enabled = abs_a.enabled = perc_a.enabled = false
			)
			else
			(
				insel_a.enabled =insel_b.enabled =insel_c.enabled = true
				rel_a.enabled = abs_a.enabled = perc_a.enabled = true
			)
				if percO_a.state == true then outsel_a.value = outsel_b.value = outsel_c.value = 100
				else outsel_a.value = outsel_b.value = outsel_c.value = 0
				if perc_a.state == true then insel_a.value = insel_b.value = insel_c.value = 100
				else insel_a.value = insel_b.value = insel_c.value = 0
				
			outsel_b.pos.x -= 15
			insel_b.pos.x -= 15
		--	locksel.changed lockSel.state
		)
		SoutselC.visible =IoutselC.visible =EoutselC.visible =SinselC.visible =IinselC.visible =EinselC.visible = not state
---------------------------
	)
	
	on getsel pressed do skintoolsenv.getsel.pressed()
	on XY pressed do skintoolsenv.rotateBone #xy
	on yz pressed do skintoolsenv.rotateBone #yz
	on xz pressed do skintoolsenv.rotateBone #xz
	on togEdit pressed do
	(
		try(if subobjectlevel == 0 then subobjectLevel = 1 else subobjectlevel = 0)catch(print"error2")
	)

--- outsel A-----------------
	on outsel_a buttondown do
	(
		skintoolsenv.outsel.buttondown()
		outsel_a.value = skintoolsenv.outsel.value
	)
	on outsel_a changed val do
	(
		if skintoolsenv.Soutsel.checked != true do skintoolsenv.Soutsel.checked = true
		if skintoolsenv.Ioutsel.checked != false do skintoolsenv.Ioutsel.checked = false 
		if skintoolsenv.Eoutsel.checked != false do skintoolsenv.Eoutsel.checked = false 
		if SoutselC.checked do
		(
			skintoolsenv.Ioutsel.checked = IoutselC.checked--true
			skintoolsenv.Eoutsel.checked = EoutselC.checked--true
		)
		if locksel.state do
		(--
			if skintoolsenv.Sinsel.checked != true do skintoolsenv.Sinsel.checked = true 
			--skintoolsenv.Sinsel.checked = SoutselC.checked--true
			if SoutselC.checked then
			(
				skintoolsenv.Iinsel.checked = IoutselC.checked--true
				skintoolsenv.Einsel.checked = EoutselC.checked--true
			)
			else
			(
				skintoolsenv.Iinsel.checked = false
				skintoolsenv.Einsel.checked = false
			)
		)
		skintoolsenv.outsel.changed val
		skintoolsenv.outsel.value = outsel_a.value
		
	)
	on outsel_a buttonup do
	(
		skintoolsenv.outsel.buttonup()
		outsel_a.value = skintoolsenv.outsel.value
	)
	on outsel_a entered do
	(
		skintoolsenv.outsel.entered()
		outsel_a.value = skintoolsenv.outsel.value
	)
-----------------------------	
--- outsel B-----------------
	on outsel_b buttondown do
	(
		skintoolsenv.outsel.buttondown()
		outsel_b.value = skintoolsenv.outsel.value
	)
	on outsel_b changed val do
	(
		if skintoolsenv.Soutsel.checked != false do skintoolsenv.Soutsel.checked = false 
		if skintoolsenv.Ioutsel.checked != true do skintoolsenv.Ioutsel .checked = true
		if skintoolsenv.Eoutsel.checked != false do skintoolsenv.Eoutsel .checked = false 
		if locksel.state do
		(
			if skintoolsenv.Iinsel.checked != true do skintoolsenv.Iinsel .checked = true
			if IoutselC.checked then
			(
				skintoolsenv.Sinsel.checked = SoutselC.checked--true
				skintoolsenv.Einsel.checked = EoutselC.checked--true
			)
			else
			(
				skintoolsenv.Sinsel.checked = false
				skintoolsenv.Einsel.checked = false
			)
		)
		if IoutselC.checked do
		(
			skintoolsenv.Soutsel.checked = SoutselC.checked
			skintoolsenv.Eoutsel.checked = EoutselC.checked 
		)
		skintoolsenv.outsel.changed val
		skintoolsenv.outsel.value = outsel_b.value
	)
	on outsel_b buttonup do
	(
		outsel_b.value = skintoolsenv.outsel.value
		skintoolsenv.outsel.buttonup()
	)
	on outsel_b entered do
	(
		skintoolsenv.outsel.entered()
		outsel_b.value = skintoolsenv.outsel.value

	)
-----------------------------	
--- outsel c-----------------
	on outsel_c buttondown do
	(
		skintoolsenv.outsel.buttondown()
		outsel_c.value = skintoolsenv.outsel.value
	)
	on outsel_c changed val do
	(
		if skintoolsenv.Soutsel.checked != false do skintoolsenv.Soutsel.checked = false 
		if skintoolsenv.Ioutsel.checked != false do skintoolsenv.Ioutsel .checked = false
		if skintoolsenv.Eoutsel.checked != true do skintoolsenv.Eoutsel .checked = true 
		if locksel.state do
		(
		--	if skintoolsenv.Sinsel.checked != false do skintoolsenv.Sinsel.checked = false 
		--	if skintoolsenv.Iinsel.checked != false do skintoolsenv.Iinsel .checked = false
			if skintoolsenv.Einsel.checked != true do skintoolsenv.Einsel .checked = true 
			if EoutselC.checked then
			(
				skintoolsenv.Iinsel.checked = IoutselC.checked--true
				skintoolsenv.Sinsel.checked = SoutselC.checked--true
			)
			else
			(
				skintoolsenv.Iinsel.checked = false
				skintoolsenv.Sinsel.checked = false
			)

		)
		if EoutselC.checked do
		(
			skintoolsenv.Ioutsel.checked = IoutselC.checked
			skintoolsenv.Soutsel.checked = SoutselC.checked
		)
		skintoolsenv.outsel.changed val
		skintoolsenv.outsel.value = outsel_c.value
	)
	on outsel_c buttonup do
	(
		skintoolsenv.outsel.buttonup()
		outsel_c.value = skintoolsenv.outsel.value
	)
	on outsel_c entered do
	(
		skintoolsenv.outsel.entered()
		outsel_c.value = skintoolsenv.outsel.value
	)
-----------------------------	
--- insel A-----------------
	on insel_a buttondown do
	(
		insel_a.value = skintoolsenv.insel.value
		skintoolsenv.insel.buttondown()
	)
	on insel_a changed val do
	(
		if skintoolsenv.Sinsel.checked != true do skintoolsenv.Sinsel.checked = true
		if skintoolsenv.Iinsel.checked != false do skintoolsenv.Iinsel .checked = false 
		if skintoolsenv.Einsel.checked != false do skintoolsenv.Einsel .checked = false 
		if SinselC.checked do
		(
			skintoolsenv.Iinsel.checked = IinselC.checked
			skintoolsenv.Einsel.checked = EinselC.checked
		)
		skintoolsenv.insel.changed val
		skintoolsenv.insel.value = insel_a.value
	)
	on insel_a buttonup do
	(
		skintoolsenv.insel.buttonup()
		insel_a.value = skintoolsenv.insel.value
	)
	on insel_a entered do
	(
		skintoolsenv.insel.entered()
		insel_a.value = skintoolsenv.insel.value
	)
-----------------------------	
--- insel B-----------------
	on insel_b buttondown do
	(
		insel_b.value = skintoolsenv.insel.value
		skintoolsenv.insel.buttondown()
	)
	on insel_b changed val do
	(
		if skintoolsenv.Sinsel.checked != false do skintoolsenv.Sinsel.checked = false 
		if skintoolsenv.Iinsel.checked != true do skintoolsenv.Iinsel .checked = true
		if skintoolsenv.Einsel.checked != false do skintoolsenv.Einsel .checked = false 
		if IinselC.checked do
		(
			skintoolsenv.Sinsel.checked = SinselC.checked
			skintoolsenv.Einsel.checked = EinselC.checked
		)
		skintoolsenv.insel.changed val
		skintoolsenv.insel.value = insel_b.value
	)
	on insel_b buttonup do
	(
		skintoolsenv.insel.buttonup()
		insel_b.value = skintoolsenv.insel.value
	)
	on insel_b entered do
	(
		skintoolsenv.insel.entered()
		insel_b.value = skintoolsenv.insel.value
	)
-----------------------------	
--- insel c-----------------
	on insel_c buttondown do
	(
		insel_c.value = skintoolsenv.insel.value
		skintoolsenv.insel.buttondown()
	)
	on insel_c changed val do
	(
		if skintoolsenv.Sinsel.checked != false do skintoolsenv.Sinsel.checked = false 
		if skintoolsenv.Iinsel.checked != false do skintoolsenv.Iinsel .checked = false
		if skintoolsenv.Einsel.checked != true do skintoolsenv.Einsel .checked = true 
		if EinselC.checked do
		(
			skintoolsenv.Iinsel.checked = IinselC.checked
			skintoolsenv.Sinsel.checked = SinselC.checked
		)
		skintoolsenv.insel.changed val
		skintoolsenv.insel.value = insel_c.value
	)
	on insel_c buttonup do
	(
		skintoolsenv.insel.buttonup()
		insel_c.value = skintoolsenv.insel.value
	)
	on insel_c entered do
	(
		skintoolsenv.insel.entered()
		insel_c.value = skintoolsenv.insel.value
	)
-----------------------------	



--UI stuff----------- _a
	on RelO_a changed state do
	(
		if state == false AND absO_a.checked == false AND percO_a.checked == false do RelO_a.state = true
		absO_a.checked = percO_a.checked = false; outsel_a.value =outsel_b.value =outsel_c.value = 0
		if lockSel.state do (Rel_a.state = state; Rel_a.changed state)
		skintoolsenv.RelO.state = state
		skintoolsenv.RelO.changed state
	)
	on absO_a changed state do
	(
		if state == false AND RelO_a.checked == false AND percO_a.checked == false do absO_a.state = true
		RelO_a.checked = percO_a.checked = false; outsel_a.value =outsel_b.value =outsel_c.value = 0
		if lockSel.state do (abs_a.state = state; abs_a.changed state)
		skintoolsenv.absO.state = state
		skintoolsenv.absO.changed state
	)
	on percO_a changed state do 
	(
		if state == false AND absO_a.checked == false AND percO_a.checked == false do percO_a.state = true
		absO_a.checked = RelO_a.checked = false; outsel_a.value = outsel_b.value = outsel_c.value = 100
		if lockSel.state do (perc_a.state = state; perc_a.changed state)
		skintoolsenv.percO.state = state
		skintoolsenv.percO.changed state
	)
	on Rel_a changed state do
	(
		if state == false AND abs_a.checked == false AND perc_a.checked == false do Rel_a.state = true
		abs_a.checked = perc_a.checked = false; insel_a.value = insel_b.value = insel_c.value = 0
		skintoolsenv.Rel.state = state
		skintoolsenv.Rel.changed state
	)
	on abs_a changed state do
	(
		if state == false AND Rel_a.checked == false AND perc_a.checked == false do abs_a.state = true
		Rel_a.checked = perc_a.checked = false; insel_a.value = insel_b.value = insel_c.value = 0
		skintoolsenv.abs.state = state
		skintoolsenv.abs.changed state
	)
	on perc_a changed state do 
	(
		if state == false AND abs_a.checked == false AND perc_a.checked == false do perc_a.state = true
		abs_a.checked = Rel_a.checked = false; insel_a.value = insel_b.value = insel_c.value = 100
		skintoolsenv.perc.state = state
		skintoolsenv.perc.changed state
	)
-----------------------------------

	on paintWeights pressed do
		skinOps.paintWeightsButton selection[1].modifiers [skintoolsenv.skin_index]
	on paintSetup pressed do
		skinOps.paintOptionsButton selection[1].modifiers [skintoolsenv.skin_index]
		
	on updte pressed do
	(	valtoassign = getSelVertWeight()
		case valtoassign of
		(
			#indeterminate: weightSpin.indeterminate = true
			default: weightSpin.value = valtoassign 
		)
	)	
	on weightSpin changed val do setSelVertWeight val
	
	on locksel changed state do
	(
		insel_a.enabled = insel_b.enabled = insel_c.enabled = not state
		rel_a.enabled = abs_a.enabled = perc_a.enabled = not state

		skintoolsenv.locksel.state = state
		skintoolsenv.locksel.changed state
	)
		fn ST_redrawviews_cb =
		(
			valtoassign = selectedBoneFloater.getSelVertWeight()
			if valtoassign == undefined do return()
			case valtoassign of
			(
				#indeterminate: (selectedBoneFloater.weightSpin.value = .9125489; selectedBoneFloater.weightSpin.indeterminate = true)
				default: selectedBoneFloater.weightSpin.value = valtoassign 
			)
		)
		fn ST_rvcb = ST_redrawviews_cb() 
	
	on selectedbonefloater open do
	(
		RelO_a.state = skintoolsenv.RelO.state
		absO_a.state = skintoolsenv.absO.state
		percO_a.state = skintoolsenv.percO.state
		if percO_a.state do percO_a.changed true
		Rel_a.state = skintoolsenv.Rel.state
		abs_a.state = skintoolsenv.abs.state
		perc_a.state = skintoolsenv.perc.state
		if perc_a.state do perc_a.changed true
		envOrCrs.state=skintoolsenv.envOrCrs.state
		if envOrCrs.state do envOrCrs.changed envOrCrs.state
	-- this bit here should be done 
		inval = (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloaterPos")
		if execute inval != OK then setdialogpos selectedbonefloater (execute inval)
		else setdialogpos selectedbonefloater [100,100]
		if (getdialogpos selectedbonefloater).x < 0 do setdialogpos selectedbonefloater [100,100]
		locksel.state = skintoolsenv.lockSel.state
		locksel.changed skintoolsenv.lockSel.state
		if getdialogpos selectedbonefloater == [-500,-500] do setdialogpos subroll [100,100]
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L1")
		if inval != OK do Soutselc.state = inval
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L2")
		if inval != OK do Ioutselc.state = inval
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L3")
		if inval != OK do Eoutselc.state = inval
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L4")
		if inval != OK do Sinselc.state = inval
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L5")
		if inval != OK do Iinselc.state = inval
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L6")
		if inval != OK do Einselc.state = inval

		unRegisterRedrawViewsCallback ST_rvcb 
		registerRedrawViewsCallback ST_rvcb 

	)
	on selectedbonefloater close do
	(
		unRegisterRedrawViewsCallback ST_rvcb 
		--save position
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloaterPos" ((getdialogpos selectedbonefloater) as string)
		try(
		if skintoolsenv.whereWasI.x < 0 do skintoolsenv.whereWasI = [100,100]
		setdialogpos subroll skintoolsenv.whereWasI
		)catch()
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L1" (Soutselc.state as string)
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L2" (Ioutselc.state as string)
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L3" (Eoutselc.state as string)
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L4" (Sinselc.state as string)
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L5" (Iinselc.state as string)
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "selectedbonefloater_L6" (Einselc.state as string)
	)
)

--- start all bones floater
rollout allBoneFloater "All Bones" width:190 height:282
(
	-- some functions
	fn getSelVertWeight =
	(	if selection[1] == undefined do return()
		if (modpanel.getCurrentObject()) == undefined do return()
		try(skin_index = modPanel.getModifierIndex selection[1] (modpanel.getCurrentObject()))catch(return())
		if skin_index == undefined do return()
		skinActive = selection[1].modifiers [skin_index]
		if classof skinActive != skin do return()
		numVerts = skinOps.GetNumberVertices skinActive 
		selVerts = for i in 1 to numVerts where skinOps.IsVertexSelected skinActive  i == 1 collect i
		if selVerts.count != 1 do return(#indeterminate)
		whichBone = skinOps.GetSelectedBone skinActive 
		whichLocalBone = undefined
		numweights = skinOps.GetVertexWeightCount skinActive selverts[1]
		for i in 1 to numweights do
		(
			if (skinOps.GetVertexWeightBoneID skinActive selVerts[1] i) == whichBone do 
			(	
				whichLocalBone = i
				exit
			)
		)
		if whichLocalBone == undefined do return 0.0
		return skinOps.GetVertexWeight skinActive selverts[1] whichLocalBone 
	)
	fn setSelVertWeight val =
	(
		skin_index = modPanel.getModifierIndex selection[1] (modpanel.getCurrentObject())
		skinActive = selection[1].modifiers [skin_index]
		if classof skinActive != skin do return()
		numVerts = skinOps.GetNumberVertices skinActive 
		selVerts = for i in 1 to numVerts where skinOps.IsVertexSelected skinActive  i == 1 collect i
		whichBone = skinOps.GetSelectedBone skinActive
		with redraw off
		(
			for i in selVerts do 
				skinOps.SetVertexWeights skinActive i whichBone val
		)
	)

	checkbutton envOrCrs "CrossSections" pos:[5,32] width:76 height:21 highlightColor:(color 140 140 255)
	checkbutton lockMove "L" pos:[84,32] width:13 height:21 enabled:false highlightColor:(color 140 140 255)
	
	GroupBox grp1 "All Bones" pos:[4,97] width:180 height:153
	spinner outall_a "" pos:[92,116] width:43 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	checkbutton relAO_a "R" pos:[141,137] width:12 height:15 highlightColor:(color 200 255 200) checked:true
	checkbutton absAO_a "A" pos:[154,137] width:11 height:15 highlightColor:(color 200 200 255)
	checkbutton percAO_a "%" pos:[166,137] width:12 height:15 highlightColor:(color 255 128 128)
	checkbutton percAOM "%" pos:[166,137] width:12 height:15 highlightColor:(color 255 128 128) visible:false
	checkbutton relA_a "R" pos:[141,204] width:12 height:15 highlightColor:(color 200 255 200) checked:true
	checkbutton absA_a "A" pos:[154,204] width:11 height:15 highlightColor:(color 200 200 255)
	checkbutton percA_a "%" pos:[166,204] width:12 height:15 highlightColor:(color 255 128 128)
	checkbutton percAM "%" pos:[166,204] width:12 height:15 highlightColor:(color 255 128 128) visible:false
	spinner inall_a "" pos:[90,184] width:45 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	button getsel "Rebuild Selection Sets/Bones" pos:[5,255] width:180 height:22
	GroupBox grp5 "Move Ends Axis" pos:[4,58] width:180 height:37
	radiobuttons rdo1 "" pos:[13,74] width:187 height:16 enabled:false labels:#("Long", "Other1", "Other2") columns:3
	
	label Soutall "Start" pos:[57,117] height:14
	label Ioutall "Inner" pos:[57,137] height:14
	label Eoutall "End" pos:[57,157] height:14
	
	label Sinall "Start" pos:[57,185] height:14 
	label Iinall "Inner" pos:[57,205] height:14
	label Einall "End" pos:[57,225] height:14 	
	checkbutton SoutallC "L" pos:[38,116] width:17 height:14 checked:false
	checkbutton IoutallC "L" pos:[38,136] width:17 height:14 checked:false
	checkbutton EoutallC "L" pos:[38,156] width:17 height:14 checked:false
	
	checkbutton SinallC "L" pos:[38,186] width:17 height:14 checked:false
	checkbutton IinallC "L" pos:[38,205] width:17 height:14 checked:false
	checkbutton EinallC "L" pos:[38,224] width:17 height:14 checked:false


	checkbutton lockall "L" pos:[17,170] width:16 height:21 highlightColor:(color 255 255 0)
	label sLabO "Outer" pos:[7,137] height:13
	label SelLabI "Inner" pos:[7,205] width:28 height:13
	label lbl23 "Rotate:" pos:[104,36] width:39 height:15
	button XY "X" pos:[140,33] width:14 height:21
	button YZ "Y" pos:[154,33] width:14 height:21
	button XZ "Z" pos:[168,33] width:14 height:21
	button togEdit "Toggle Edit Envelopes" pos:[4,5] width:180 height:21


	label sLabsAtart "Start of Envelope:" pos:[11,137] width:89 height:13 visible:false
	label SelLabEnd "End of Envelope:" pos:[11,205] width:89 height:13 visible:false

	spinner outall_b "" pos:[92,136] width:43 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	spinner outall_c "" pos:[92,156] width:43 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	spinner inall_b "" pos:[90,204] width:45 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	spinner inall_c "" pos:[90,224] width:45 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	
	on lockall changed state do
	(
		skintoolsenv.lockall.state = state
		skintoolsenv.lockall.changed state
	)
	
	on lockmove changed state do
	(
		skintoolsenv.lockmove.state = state
		skintoolsenv.lockmove.changed state
		SelLabEnd.enabled = inall_b.enabled = not state
	)
	on rdo1 changed state do
	(
	skintoolsenv.rdo1.state = state
	skintoolsenv.rdo1.changed state
	)

	on envOrCrs changed state do
	(
		skintoolsenv.envOrCrs.state = state
		skintoolsenv.envOrCrs.changed state

---------------------------
			rdo1.enabled = envOrCrs.state
			XY.enabled = YZ.enabled = xz.enabled = not envOrCrs.state
			if state then 
			(
				lockMove.enabled = true
				inall_c.enabled = not lockMove.state
				envOrCrs.caption = "Env. Ends"
				absA_a.visible = relA_a.visible = percA_a.visible = \
				absAO_a.visible = relAO_a.visible = percAO_a.visible =  false
			Soutall.visible = Ioutall.visible = Eoutall.visible = \
			Sinall.visible =Iinall.visible =Einall.visible = false
				percAM.visible = \
				percAOM.visible = true
				
				percAM.state = skintoolsenv.percAM.state
				percAOM.state = skintoolsenv.percAOM.state
				
			sLabO.visible =\
			SelLabI.visible = false
				
			sLabsAtart.visible =\
			SelLabEnd.visible = true
			
			lockall.visible = false
			
			outall_b.pos.x += 15
			inall_b.pos.x += 15
			
			outall_a.visible = outall_c.visible = inall_a.visible = inall_c.visible = false
				outall_a.value = 0
				inall_a.value = 0
				outall_b.value = 0
				inall_b.value = 0
				outall_c.value = 0
				inall_c.value = 0
				inall_b.enabled = not lockMove.state
			)
			else 
			( 
				lockMove.enabled = false
				inall_c.enabled = true
				envOrCrs.caption = "CrossSections"
				absA_a.visible = relA_a.visible = percA_a.visible = \
				absAO_a.visible = relAO_a.visible = percAO_a.visible =  true
			Soutall.visible = Ioutall.visible = Eoutall.visible = \
			Sinall.visible =Iinall.visible =Einall.visible = true
		
				percAM.visible = \
				percAOM.visible = false
				
			sLabO.visible =\
			SelLabI.visible =true
			sLabsAtart.visible =\
			SelLabEnd.visible =false
			lockall.visible =true
			outall_a.visible = outall_c.visible = inall_a.visible = inall_c.visible = true
			outall_a.enabled = outall_b.enabled = outall_c.enabled = inall_a.visible = true
			
			if lockall.state then
			(
				inall_a.enabled =inall_b.enabled =inall_c.enabled = false
				relA_a.enabled = absA_a.enabled = percA_a.enabled = false
			)
			else
			(
				inall_a.enabled =inall_b.enabled =inall_c.enabled = true
				relA_a.enabled = absA_a.enabled = percA_a.enabled = true
			)
				if percAO_a.state == true then outall_a.value = outall_b.value = outall_c.value = 100
				else outall_a.value = outall_b.value = outall_c.value = 0
				if percA_a.state == true then inall_a.value = inall_b.value = inall_c.value = 100
				else inall_a.value = inall_b.value = inall_c.value = 0
				
			outall_b.pos.x -= 15
			inall_b.pos.x -= 15
		--	lockall.changed lockall.state
		)
		SoutallC.visible =IoutallC.visible =EoutallC.visible =SinallC.visible =IinallC.visible =EinallC.visible = not state
---------------------------
	)
	
	on getsel pressed do skintoolsenv.getsel.pressed()
	on XY pressed do skintoolsenv.rotateBone #xy
	on yz pressed do skintoolsenv.rotateBone #yz
	on xz pressed do skintoolsenv.rotateBone #xz
	on togEdit pressed do
	(
		try(if subobjectlevel == 0 then subobjectLevel = 1 else subobjectlevel = 0)catch(print"error2")
	)

--- outall A-----------------
	on outall_a buttondown do
	(
		skintoolsenv.outall.buttondown()
		outall_a.value = skintoolsenv.outall.value
	)
	on outall_a changed val do
	(
		if skintoolsenv.Soutall.checked != true do skintoolsenv.Soutall.checked = true
		if skintoolsenv.Ioutall.checked != false do skintoolsenv.Ioutall.checked = false 
		if skintoolsenv.Eoutall.checked != false do skintoolsenv.Eoutall.checked = false 
		if SoutallC.checked do
		(
			skintoolsenv.Ioutall.checked = IoutallC.checked--true
			skintoolsenv.Eoutall.checked = EoutallC.checked--true
		)
		if lockall.state do
		(--
			if skintoolsenv.Sinall.checked != true do skintoolsenv.Sinall.checked = true 
			--skintoolsenv.Sinall.checked = SoutallC.checked--true
			if SoutallC.checked then
			(
				skintoolsenv.Iinall.checked = IoutallC.checked--true
				skintoolsenv.Einall.checked = EoutallC.checked--true
			)
			else
			(
				skintoolsenv.Iinall.checked = false
				skintoolsenv.Einall.checked = false
			)
		)
		skintoolsenv.outall.changed val
		skintoolsenv.outall.value = outall_a.value
		
	)
	on outall_a buttonup do
	(
		skintoolsenv.outall.buttonup()
		outall_a.value = skintoolsenv.outall.value
	)
	on outall_a entered do
	(
		skintoolsenv.outall.entered()
		outall_a.value = skintoolsenv.outall.value
	)
-----------------------------	
--- outall B-----------------
	on outall_b buttondown do
	(
		skintoolsenv.outall.buttondown()
		outall_b.value = skintoolsenv.outall.value
	)
	on outall_b changed val do
	(
		if skintoolsenv.Soutall.checked != false do skintoolsenv.Soutall.checked = false 
		if skintoolsenv.Ioutall.checked != true do skintoolsenv.Ioutall .checked = true
		if skintoolsenv.Eoutall.checked != false do skintoolsenv.Eoutall .checked = false 
		if lockall.state do
		(
			if skintoolsenv.Iinall.checked != true do skintoolsenv.Iinall .checked = true
			if IoutallC.checked then
			(
				skintoolsenv.Sinall.checked = SoutallC.checked--true
				skintoolsenv.Einall.checked = EoutallC.checked--true
			)
			else
			(
				skintoolsenv.Sinall.checked = false
				skintoolsenv.Einall.checked = false
			)
		)
		if IoutallC.checked do
		(
			skintoolsenv.Soutall.checked = SoutallC.checked
			skintoolsenv.Eoutall.checked = EoutallC.checked 
		)
		skintoolsenv.outall.changed val
		skintoolsenv.outall.value = outall_b.value
	)
	on outall_b buttonup do
	(
		skintoolsenv.outall.buttonup()
		outall_b.value = skintoolsenv.outall.value
	)
	on outall_b entered do
	(
		skintoolsenv.outall.entered()
		outall_b.value = skintoolsenv.outall.value

	)
-----------------------------	
--- outall c-----------------
	on outall_c buttondown do
	(
		skintoolsenv.outall.buttondown()
		outall_c.value = skintoolsenv.outall.value
	)
	on outall_c changed val do
	(
		if skintoolsenv.Soutall.checked != false do skintoolsenv.Soutall.checked = false 
		if skintoolsenv.Ioutall.checked != false do skintoolsenv.Ioutall .checked = false
		if skintoolsenv.Eoutall.checked != true do skintoolsenv.Eoutall .checked = true 
		if lockall.state do
		(
		--	if skintoolsenv.Sinall.checked != false do skintoolsenv.Sinall.checked = false 
		--	if skintoolsenv.Iinall.checked != false do skintoolsenv.Iinall .checked = false
			if skintoolsenv.Einall.checked != true do skintoolsenv.Einall .checked = true 
			if EoutallC.checked then
			(
				skintoolsenv.Iinall.checked = IoutallC.checked--true
				skintoolsenv.Sinall.checked = SoutallC.checked--true
			)
			else
			(
				skintoolsenv.Iinall.checked = false
				skintoolsenv.Sinall.checked = false
			)

		)
		if EoutallC.checked do
		(
			skintoolsenv.Ioutall.checked = IoutallC.checked
			skintoolsenv.Soutall.checked = SoutallC.checked
		)
		skintoolsenv.outall.changed val
		skintoolsenv.outall.value = outall_c.value
	)
	on outall_c buttonup do
	(
		skintoolsenv.outall.buttonup()
		outall_c.value = skintoolsenv.outall.value
	)
	on outall_c entered do
	(
		skintoolsenv.outall.entered()
		outall_c.value = skintoolsenv.outall.value
	)
-----------------------------	
--- inall A-----------------
	on inall_a buttondown do
	(
		inall_a.value = skintoolsenv.inall.value
		skintoolsenv.inall.buttondown()
	)
	on inall_a changed val do
	(
		if skintoolsenv.Sinall.checked != true do skintoolsenv.Sinall.checked = true
		if skintoolsenv.Iinall.checked != false do skintoolsenv.Iinall .checked = false 
		if skintoolsenv.Einall.checked != false do skintoolsenv.Einall .checked = false 
		if SinallC.checked do
		(
			skintoolsenv.Iinall.checked = IinallC.checked
			skintoolsenv.Einall.checked = EinallC.checked
		)
		skintoolsenv.inall.changed val
		skintoolsenv.inall.value = inall_a.value
	)
	on inall_a buttonup do
	(
		skintoolsenv.inall.buttonup()
		inall_a.value = skintoolsenv.inall.value
	)
	on inall_a entered do
	(
		skintoolsenv.inall.entered()
		inall_a.value = skintoolsenv.inall.value
	)
-----------------------------	
--- inall B-----------------
	on inall_b buttondown do
	(
		inall_b.value = skintoolsenv.inall.value
		skintoolsenv.inall.buttondown()
	)
	on inall_b changed val do
	(
		if skintoolsenv.Sinall.checked != false do skintoolsenv.Sinall.checked = false 
		if skintoolsenv.Iinall.checked != true do skintoolsenv.Iinall .checked = true
		if skintoolsenv.Einall.checked != false do skintoolsenv.Einall .checked = false 
		if IinallC.checked do
		(
			skintoolsenv.Sinall.checked = SinallC.checked
			skintoolsenv.Einall.checked = EinallC.checked
		)
		skintoolsenv.inall.changed val
		skintoolsenv.inall.value = inall_b.value
	)
	on inall_b buttonup do
	(
		skintoolsenv.inall.buttonup()
		inall_b.value = skintoolsenv.inall.value
	)
	on inall_b entered do
	(
		skintoolsenv.inall.entered()
		inall_b.value = skintoolsenv.inall.value
	)
-----------------------------	
--- inall c-----------------
	on inall_c buttondown do
	(
		inall_c.value = skintoolsenv.inall.value
		skintoolsenv.inall.buttondown()
	)
	on inall_c changed val do
	(
		if skintoolsenv.Sinall.checked != false do skintoolsenv.Sinall.checked = false 
		if skintoolsenv.Iinall.checked != false do skintoolsenv.Iinall .checked = false
		if skintoolsenv.Einall.checked != true do skintoolsenv.Einall .checked = true 
		if EinallC.checked do
		(
			skintoolsenv.Iinall.checked = IinallC.checked
			skintoolsenv.Sinall.checked = SinallC.checked
		)
		skintoolsenv.inall.changed val
		skintoolsenv.inall.value = inall_c.value
	)
	on inall_c buttonup do
	(
		skintoolsenv.inall.buttonup()
		inall_c.value = skintoolsenv.inall.value
	)
	on inall_c entered do
	(
		skintoolsenv.inall.entered()
		inall_c.value = skintoolsenv.inall.value
	)
-----------------------------	



--UI stuff----------- _a
	on relAO_a changed state do
	(
		if state == false AND absAO_a.checked == false AND percAO_a.checked == false do relAO_a.state = true
		absAO_a.checked = percAO_a.checked = false; outall_a.value =outall_b.value =outall_c.value = 0
		if lockall.state do (relA_a.state = state; relA_a.changed state)
		skintoolsenv.relAO.state = state
		skintoolsenv.relAO.changed state
	)
	on absAO_a changed state do
	(
		if state == false AND relAO_a.checked == false AND percAO_a.checked == false do absAO_a.state = true
		relAO_a.checked = percAO_a.checked = false; outall_a.value =outall_b.value =outall_c.value = 0
		if lockall.state do (absA_a.state = state; absA_a.changed state)
		skintoolsenv.absAO.state = state
		skintoolsenv.absAO.changed state
	)
	on percAO_a changed state do 
	(
		if state == false AND absAO_a.checked == false AND percAO_a.checked == false do percAO_a.state = true
		absAO_a.checked = relAO_a.checked = false; outall_a.value = outall_b.value = outall_c.value = 100
		if lockall.state do (percA_a.state = state; percA_a.changed state)
		skintoolsenv.percAO.state = state
		skintoolsenv.percAO.changed state
	)
	on relA_a changed state do
	(
		if state == false AND absA_a.checked == false AND percA_a.checked == false do relA_a.state = true
		absA_a.checked = percA_a.checked = false; inall_a.value = inall_b.value = inall_c.value = 0
		skintoolsenv.relA.state = state
		skintoolsenv.relA.changed state
	)
	on absA_a changed state do
	(
		if state == false AND relA_a.checked == false AND percA_a.checked == false do absA_a.state = true
		relA_a.checked = percA_a.checked = false; inall_a.value = inall_b.value = inall_c.value = 0
		skintoolsenv.absA.state = state
		skintoolsenv.absA.changed state
	)
	on percA_a changed state do 
	(
		if state == false AND absA_a.checked == false AND percA_a.checked == false do percA_a.state = true
		absA_a.checked = relA_a.checked = false; inall_a.value = inall_b.value = inall_c.value = 100
		skintoolsenv.percA.state = state
		skintoolsenv.percA.changed state
	)
-----------------------------------
		
	on lockall changed state do
	(
		inall_a.enabled = inall_b.enabled = inall_c.enabled = not state
		relA_a.enabled = absA_a.enabled = percA_a.enabled = not state

		skintoolsenv.lockall.state = state
		skintoolsenv.lockall.changed state
	)
	
	on allBoneFloater open do
	(
		relAO_a.state = skintoolsenv.relAO.state
		absAO_a.state = skintoolsenv.absAO.state
		percAO_a.state = skintoolsenv.percAO.state
		if percAO_a.state do percAO_a.changed true
		relA_a.state = skintoolsenv.relA.state
		absA_a.state = skintoolsenv.absA.state
		percA_a.state = skintoolsenv.percA.state
		if percA_a.state do percA_a.changed true
		envOrCrs.state=skintoolsenv.envOrCrs.state
		if envOrCrs.state do envOrCrs.changed envOrCrs.state
	-- this bit here should be done 
		inval = (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloaterPos")
		if execute inval != OK then setdialogpos allBoneFloater (execute inval)
		else setdialogpos allBoneFloater [100,100]
		if (getdialogpos selectedbonefloater).x < 0 do setdialogpos allBoneFloater [100,100]
		lockall.state = skintoolsenv.lockall.state
		lockall.changed skintoolsenv.lockall.state
		if getdialogpos allBoneFloater == [-500,-500] do setdialogpos subroll [100,100]
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L1")
		if inval != OK do Soutallc.state = inval
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L2")
		if inval != OK do Ioutallc.state = inval
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L3")
		if inval != OK do Eoutallc.state = inval
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L4")
		if inval != OK do Sinallc.state = inval
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L5")
		if inval != OK do Iinallc.state = inval
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L6")
		if inval != OK do Einallc.state = inval

	)
	on allBoneFloater close do
	(
		--save position
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloaterPos" ((getdialogpos allbonefloater) as string)
		try(
		if skintoolsenv.whereWasI.x < 0 do skintoolsenv.whereWasI = [100,100]
		setdialogpos subroll skintoolsenv.whereWasI
		)catch()
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L1" (Soutallc.state as string)
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L2" (Ioutallc.state as string)
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L3" (Eoutallc.state as string)
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L4" (Sinallc.state as string)
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L5" (Iinallc.state as string)
		setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "allBoneFloater_L6" (Einallc.state as string)
	)
)
--createdialog allbonefloater

-------------------end all bones floater
rcmenu stmenu
(
	submenu "Floaters"
	(
		menuitem mi_SelFloater "Selected Bones Floater..."
		menuitem mi_AllFloater "All Bones Floater..."
		--menuitem mi_MSFloater "Named Selections Floater..."
	)
	--
	submenu "Misc."
	(
		menuitem mi_remMult "Remove Multiple Bones..."
		menuitem mi_revBone "Reverse (Single) Bone"
		menuitem mi_repBone "Replace Bone"
	)
	submenu "Dock"
	(
		menuitem mi_dock_left "Dock Left"
		menuitem mi_dock_right "Dock Right"
		separator sep1
		menuitem mi_undock "Undock"
	)
	
	on mi_remMult picked do skintoolsenv.remMult()
	on mi_revBone picked do skintoolsenv.revBone()
	on mi_SelFloater picked do(
		skintoolsenv.whereWasI = getdialogpos subroll
		setdialogpos subroll [-500,-500]
		createdialog selectedbonefloater pos:[-500,-500]
	)
	
	on mi_AllFloater picked do(
		skintoolsenv.whereWasI = getdialogpos subroll
		setdialogpos subroll [-500,-500]
		createdialog allBoneFloater pos:[-500,-500]
	)
	
	-- make dockable
	on mi_dock_right picked do
	(
		subroll.height = 900
		subroll.stsubroll.height = 900
		cui.RegisterDialogBar subroll  style:#(#cui_dock_vert, #cui_floatable, #cui_handles,#cui_max_sized) --minsize:[205,(systemTools.getScreenHeight()-100)] maxsize:[-1,-1] 
		cui.DockDialogBar subroll #cui_dock_right
	)
	on mi_dock_left picked do
	(
		subroll.height = 680
		subroll.stsubroll.height = 680
		cui.RegisterDialogBar subroll  style:#(#cui_dock_vert, #cui_floatable, #cui_handles,#cui_max_sized) --minsize:[205,(systemTools.getScreenHeight()-100)] maxsize:[-1,-1] 
		cui.DockDialogBar subroll #cui_dock_left
	)
	on mi_undock picked do cui.UnRegisterDialogBar subRoll
	on mi_repBone picked do
	(	if skintoolsenv.skin_index == undefined do return()
		newBone = pickobject count:1 message:"Pick a new bone object" forceListenerFocus:false
		if newbone != undefined do
			skintoolsenv.replacebone newbone
	)
)

rollout skintoolsenv "Envelopes 2.0"
(	local whereWasI
	local origval = #(), modval = #(), modvalb = #(), origvalb = #(), origval_rev = #(), boneCSarr = #(), \
	clrvrtstate = 1, a, b, c, d, temparr = #(), relselarr = #(), bonesarr = #(), STboneAxisArray = #(), STboneAxesArray = #(), STlongbone = 0, STSelBoneAxisArray = #(), STSelBoneAxesArray = #(), STsellongbone = 0, \
	ssboneCSarr = #(), selbones = #(), skin_index, bone_sel=#(), ussarr=#(), ussarr_b=#(), sbc, st_opened = false
	local lastRotated, lastRotatedXform, lastStart, lastEnd
	local origValOut = #(), origValIn = #(), origValOutb = #(), origValInb = #(), modValIn = #(), modValOut = #()
--------some functions
fn rotateBone which = 
(
	skin_index = modPanel.getModifierIndex selection[1] (modpanel.getCurrentObject())
	if classof (modPanel.getCurrentObject()) != Skin do return()
	undo "Rotate Bone" on
	(
		(
			a = skinops.GetSelectedBone selection[1].modifiers[skin_index]
			if a != skintoolsenv.lastRotated do
			(
			 	skintoolsenv.lastRotated = a
				skintoolsenv.lastRotatedXform = undefined
			)
		-- get the start and endpoints:
			v1 = skinOps.getstartpoint selection[1].modifiers[skin_index] a
			v2 = skinOps.getendpoint selection[1].modifiers[skin_index] a
		-- build a matrix to work around. The second axis is startpoint offset by one unit in its X
			if skintoolsenv.lastRotatedXform == undefined OR v1 != skintoolsenv.lastStart OR v2 != skintoolsenv.lastEnd then
			(
				ax1 = normalize (v2 - v1)
				ax2 =  normalize (((v1 + [0,1,0]) - v1))
				ax3 = normalize (cross ax1 ax2)
				ax2 = normalize (cross ax1 ax3)
				trfrm = matrix3 ax1 ax2 ax3 ((v2+v1)/2)
				skintoolsenv.lastRotatedXform = trfrm
				skintoolsenv.lastStart = v1
				skintoolsenv.lastEnd = v2
			)
			else
			(
				trfrm = skintoolsenv.lastRotatedXform 
			)
			start = matrix3 1
			start.pos = v1
			end = matrix3 1
			end.pos = v2
			start = start * inverse trfrm
			case which of
			(
				#xy: rotatez start 90
				#yz: rotatey start 90
				#xz: rotatex start 90
			)
			start = start * trfrm
			end = end * inverse trfrm
			case which of
			(
				#xy: rotatez end 90
				#yz: rotatey end 90
				#xz: rotatex end 90
			)
			end = end * trfrm
			skinOps.setstartpoint selection[1].modifiers[skin_index] a start.pos
			skinOps.setendpoint selection[1].modifiers[skin_index] a end.pos
			skintoolsenv.lastStart = start.pos
			skintoolsenv.lastEnd = end.pos
		)
	)
)

fn replacebone newBone =
(	if newBone == undefined do return()
	undo off
	(
		if classof (modPanel.getCurrentObject()) != Skin do return()
		skin_index = modPanel.getModifierIndex selection[1] (modpanel.getCurrentObject())
		skinObj = selection[1].modifiers[skin_index]
		oldBone = skinops.GetSelectedBone skinObj
		oldBoneName = skinops.getbonename skinobj oldBone 0
	-- copy the basic setup using the built in function:
		skinops.copySelectedBone skinObj
	-- then copy the weight table:
		skinops.addbone skinObj newBone 0
		-- need to find the bone we just added...
		local newBoneIdx
		for i in 1 to (skinops.getnumberbones skinobj) do
		(
			if skinops.getbonename skinobj i 0 == newBone.name do 
			(
				newBoneIdx = i
				exit
			)
		)
		if newBoneIdx == undefined do return(messagebox "failed" title:"failure")
		-- need to find the bone we started with since the indices are now shot
		for i in 1 to (skinops.getnumberbones skinobj) do
		(
			if skinops.getbonename skinobj i 0 == oldBoneName do 
			(
				oldBone = i
				exit
			)
		)
		if oldBone == undefined do return(messagebox "failed" title:"failure")
	--(
	
	-- now get the weight table:
	
		vertArray = #()
		vertBoneArray = #()
		weightArray = #()
	--	oldBoneName = skinops.getbonename skinobj oldBone 0
		for i in 1 to (skinOps.getnumbervertices skinobj) do
		(
			if (skinops.isvertexmodified skinobj i) == 0 do continue
			numbonesAffecting = skinops.getvertexweightcount skinobj i
			vertbonearrayt = #()
			WeightArrayt = #()
			for j in 1 to numBonesAffecting do
			(	
				
				whichBone = skinops.getvertexweightboneid skinobj i j
				whichBoneName = skinops.getbonename skinobj whichBone 0
				--if whichBone == oldBone do
				(
					append vertBoneArrayt whichBoneName
					append weightArrayt (skinops.getVertexWeight skinobj i j)
				)
			)
			if finditem vertBoneArrayt oldBoneName != 0 do
			(
				append vertArray i
				append vertBoneArray vertbonearrayt 
				append weightArray WeightArrayt
			)
			
		)		
		
		-- now position the end/start points...
		-- this gets the offsets of the end points in local space for the bones
		obj1 = getnodebyname (skinops.getbonename skinObj oldBone 1)
		obj2 = getnodebyname (skinops.getbonename skinObj newBoneIdx 1)
		
		
		-- end point matching...
		startMat = obj1.transform
		endPoint =  (skinops.getEndPoint skinObj oldBone)-- this local to the bone so we need to 
		offsetMat = pretranslate startMat endPoint-- find out what it was in world space
	
		newOffset = translate obj2.transform (obj2.transform.pos - offsetMat.pos) -- and then find out what that is
		resultPos = (obj2.transform * inverse(newOffset)).pos			-- in the other bones space
		skinops.setEndPoint skinObj newBoneIdx resultPos
		
		
		-- now the start point
		startMat = obj1.transform
		StartPoint =  (skinops.getStartPoint skinObj oldBone )-- this got from where the bone was
		offsetMat = pretranslate startMat StartPoint
	
		newOffset = translate obj2.transform (obj2.transform.pos - offsetMat.pos)
		resultPos = (obj2.transform * inverse(newOffset)).pos			
		skinops.setStartPoint skinObj newBoneIdx resultPos
	--)
		skinops.selectbone skinobj newBoneIdx
		skinops.pasteToSelectedBone skinObj
		skinops.removeBone skinObj oldBone
		-- need to find it again...
		for i in 1 to (skinops.getnumberbones skinobj) do
		(
			if skinops.getbonename skinobj i 0 == newBone.name do 
			(
				newBoneIdx = i
				exit
			)
		)
		if newBoneIdx == undefined do return(messagebox "failed" title:"failure")
		skinops.selectbone skinobj newBoneIdx
	-- now set the weight table:
	--skinOps.SetVertexWeights skinobj 101 2 0.25
		-- build array of indexes:
		namearray = #()
		indexarray = #()
		for i in 1 to skinops.getnumberbones skinobj do
		(
			name = skinops.getbonename skinobj i 0
			append nameArray name
			append indexArray i
		)
		for i in 1 to weightArray.count do
		(	
			vertIndexArray = #()
			for j in vertBoneArray[i] do
			(	
				if j == oldbonename do j = newbone.name
				if (finditem nameArray j) != 0 do
				(
					append vertindexarray indexArray[(finditem nameArray j)]
				)
			)
		--	if vertarray[i] == 101 do
			--print vertArray[i]
			--print #(vertIndexArray)
			--print  #(weightArray[i])
			skinOps.ReplaceVertexWeights skinobj vertArray[i] vertIndexArray weightArray[i]
		)
	)
)


--------UI
	checkbutton envOrCrs "CrossSections" pos:[5,32] width:76 height:21 highlightColor:(color 140 140 255)
	checkbutton lockMove "L" pos:[84,32] width:13 height:21 enabled:false highlightColor:(color 140 140 255)
	
	GroupBox grp1 "Selected Bone" pos:[4,97] width:180 height:62
	spinner outsel "" pos:[98,116] width:43 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	checkbutton RelO "R" pos:[143,116] width:12 height:15 highlightColor:(color 200 255 200) checked:true
	checkbutton absO "A" pos:[156,116] width:11 height:15 highlightColor:(color 200 200 255)
	checkbutton percO "%" pos:[168,116] width:12 height:15 highlightColor:(color 255 128 128)
	checkbutton percOM "%" pos:[168,116] width:12 height:15 highlightColor:(color 255 128 128) visible:false
	spinner insel "" pos:[96,137] width:45 height:16 range:[-1000,1000,0] scale:0.1 fieldwidth:37
	checkbutton Rel "R" pos:[143,136] width:12 height:15 highlightColor:(color 200 255 200) checked:true
	checkbutton abs "A" pos:[156,136] width:11 height:15 highlightColor:(color 200 200 255)
	checkbutton perc "%" pos:[168,136] width:12 height:15 highlightColor:(color 255 128 128)
	checkbutton percM "%" pos:[168,136] width:12 height:15 highlightColor:(color 255 128 128) visible:false
	GroupBox grp2 "All Bones" pos:[4,164] width:180 height:60
	spinner outall "" pos:[92,183] width:49 height:16 range:[-10000,10000,0] scale:0.1 fieldwidth:37
	checkbutton RelAO "R" pos:[143,183] width:12 height:15 highlightColor:(color 200 255 200) checked:true
	checkbutton absAO "A" pos:[156,183] width:11 height:15 highlightColor:(color 200 200 255)
	checkbutton percAO "%" pos:[168,183] width:12 height:15 highlightColor:(color 255 128 128)
	checkbutton percAOM "%" pos:[168,183] width:12 height:15 highlightColor:(color 255 128 128) visible:false
	spinner inall "" pos:[96,203] width:45 height:16 range:[-10000,10000,0] scale:0.1 fieldwidth:37
	checkbutton RelA "R" pos:[143,203] width:12 height:15 highlightColor:(color 200 255 200) checked:true
	checkbutton absA "A" pos:[156,203] width:11 height:15 highlightColor:(color 200 200 255)
	checkbutton percA "%" pos:[168,203] width:12 height:15 highlightColor:(color 255 128 128)
	checkbutton percAM "%" pos:[168,203] width:12 height:15 highlightColor:(color 255 128 128) visible:false
	GroupBox grp3 "Named Selection" pos:[4,229] width:180 height:252
	button getsel "Rebuild Selection Sets/Bones" pos:[4,485] width:180 height:22
	dropdownList sellst "Relevant named selections:" pos:[13,287] width:162 height:40
	checkbox clrexst "Clear Existing Selection" pos:[13,332] width:134 height:15 checked:true
	multiListBox bonelst "" pos:[11,352] width:161 height:9
	spinner outns "" pos:[103,246] width:38 height:16 range:[-10000,10000,0] scale:0.1 fieldwidth:37
	checkbutton RelSO "R" pos:[143,246] width:12 height:15 highlightColor:(color 200 255 200) checked:true
	checkbutton absSO "A" pos:[156,246] width:11 height:15 highlightColor:(color 200 200 255)
	checkbutton percSO "%" pos:[168,246] width:12 height:15 highlightColor:(color 255 128 128)
	checkbutton percSOM "%" pos:[168,246] width:12 height:15 highlightColor:(color 255 128 128) visible:false
	spinner inns "" pos:[106,266] width:35 height:16 range:[-10000,10000,0] scale:0.1 fieldwidth:37
	checkbutton RelS "R" pos:[143,266] width:12 height:15 highlightColor:(color 200 255 200) checked:true
	checkbutton absS "A" pos:[156,266] width:11 height:15 highlightColor:(color 200 200 255)
	checkbutton percS "%" pos:[168,266] width:12 height:15 highlightColor:(color 255 128 128)
	checkbutton percSM "%" pos:[168,266] width:12 height:15 highlightColor:(color 255 128 128) visible:false
	
	
	GroupBox grp5 "Move Ends Axis" pos:[4,58] width:180 height:37
	radiobuttons rdo1 "" pos:[13,74] width:187 height:16 enabled:false labels:#("Long", "Other1", "Other2") columns:3
	
	checkbutton Soutsel "S" pos:[30,116] width:20 height:14 checked:true
	checkbutton Ioutsel "I" pos:[51,116] width:20 height:14 checked:true
	checkbutton Eoutsel "E" pos:[72,116] width:20 height:14 checked:true
	
	checkbutton Sinsel "S" pos:[30,136] width:20 height:14 checked:true
	checkbutton Iinsel "I" pos:[51,136] width:20 height:14 checked:true
	checkbutton Einsel "E" pos:[72,136] width:20 height:14 checked:true
	
	checkbutton Soutall "S" pos:[30,183] width:20 height:14 checked:true	
	checkbutton Ioutall "I" pos:[51,183] width:20 height:14 checked:true
	checkbutton Eoutall "E" pos:[72,183] width:20 height:14 checked:true
	
	checkbutton Sinall "S" pos:[30,203] width:20 height:14 checked:true
	checkbutton Iinall "I" pos:[51,203] width:20 height:14 checked:true
	checkbutton Einall "E" pos:[72,203] width:20 height:14 checked:true
	
	checkbutton Soutns "S" pos:[30,246] width:20 height:14 checked:true
	checkbutton Ioutns "I" pos:[51,246] width:20 height:14 checked:true
	checkbutton Eoutns "E" pos:[72,246] width:20 height:14 checked:true
	
	checkbutton Sinns "S" pos:[30,266] width:20 height:14 checked:true
	checkbutton Iinns "I" pos:[51,266] width:20 height:14 checked:true
	checkbutton Einns "E" pos:[72,266] width:20 height:14 checked:true
	
	checkbutton lockSel "L" pos:[7,127] width:10 height:14 highlightColor:(color 255 255 0)
	checkbutton lockAll "L" pos:[8,193] width:10 height:14 highlightColor:(color 255 255 0)
	checkbutton lockNS "L" pos:[8,257] width:10 height:14 highlightColor:(color 255 255 0)
	
	label sLabO "O" pos:[20,117] width:8 height:13
	label SelLabI "I" pos:[21,137] width:8 height:13
	label aLabO "O" pos:[20,184] width:8 height:13
	label aLabI "I" pos:[21,204] width:8 height:13
	label nsLabO "O" pos:[20,247] width:8 height:13
	label nsLabI "I" pos:[21,267] width:8 height:13
	label sLabStart "Start of Envelope:" pos:[11,117] width:89 height:13 visible:false
	label SelLabEnd "End of Envelope:" pos:[11,137] width:89 height:13 visible:false
	label aLabStart "Start of Envelopes:" pos:[11,184] width:92 height:13 visible:false
	label aLabEnd "End of Envelopes:" pos:[11,204] width:89 height:13 visible:false
	label nsLabStart "Start of Envelopes:" pos:[11,247] width:92 height:13 visible:false
	label nsLabEnd "End of Envelopes:" pos:[11,267] width:89 height:13 visible:false
 
	label lbl23 "Rotate:" pos:[104,36] width:39 height:15
	button XY "X" pos:[140,33] width:14 height:21
	button YZ "Y" pos:[154,33] width:14 height:21
	button XZ "Z" pos:[168,33] width:14 height:21
	button togEdit "Toggle Edit Envelopes" pos:[4,5] width:180 height:21


-- ui stuff

	on XY pressed do rotateBone #xy
	on yz pressed do rotateBone #yz
	on xz pressed do rotateBone #xz
--Lock Selected UI stuff: ------------------------------------------------------------------------------		
	
	on lockSel changed state do
	(
		if state then(
			Sinsel.state = Soutsel.state
			Iinsel.state = Ioutsel.state
			Einsel.state = Eoutsel.state
			Rel.state = RelO.state
			abs.state = absO.state
			perc.state = percO.state
		)
		Sinsel.enabled =\
		Iinsel.enabled =\
		Einsel.enabled = not state
		
		insel.enabled = not state
		
		
		Rel.enabled = \
		abs.enabled = \
		perc.enabled = not state
		
	)
	on lockAll changed state do
	(
		if state then(
			SinAll.state = SoutAll.state
			IinAll.state = IoutAll.state
			EinAll.state = EoutAll.state
			RelA.state = RelAO.state
			absA.state = absAO.state
			percA.state = percAO.state
		)
		SinAll.enabled =\
		IinAll.enabled =\
		EinAll.enabled = not state
		
		inAll.enabled = not state
		
		
		RelA.enabled = \
		absA.enabled = \
		percA.enabled = not state
		
	)
	on lockNS changed state do
	(
		if state then(
			SinNS.state = SoutNS.state
			IinNS.state = IoutNS.state
			EinNS.state = EoutNS.state
			RelS.state = RelSO.state
			absS.state = absSO.state
			percS.state = percSO.state
		)
		SinNS.enabled =\
		IinNS.enabled =\
		EinNS.enabled = not state
		
		inNS.enabled = not state
		
		
		RelS.enabled = \
		absS.enabled = \
		percS.enabled = not state
		
	)
	on Soutsel changed state do
		if lockSel.state do SinSel.state = state
	on Ioutsel changed state do
		if lockSel.state do IinSel.state = state
	on Eoutsel changed state do
		if lockSel.state do EinSel.state = state
	on Soutall changed state do
		if lockall.state do Sinall.state = state
	on Ioutall changed state do
		if lockall.state do Iinall.state = state
	on Eoutall changed state do
		if lockall.state do Einall.state = state
	on SoutNS changed state do
		if lockNS.state do SinNS.state = state
	on IoutNS changed state do
		if lockNS.state do IinNS.state = state
	on EoutNS changed state do
		if lockNS.state do EinNS.state = state
	
--------------------------------------------------------------------------------		
	
	on togEdit pressed do
	(
		try(if subobjectlevel == 0 then subobjectLevel = 1 else subobjectlevel = 0)catch(print"error3")
	)
	on RelO changed state do
	(
		if state == false AND absO.checked == false AND percO.checked == false do RelO.state = true
		absO.checked = percO.checked = false; outsel.value = 0
		if lockSel.state do (Rel.state = state; Rel.changed state)
	)
	on absO changed state do
	(
		if state == false AND RelO.checked == false AND percO.checked == false do absO.state = true
		RelO.checked = percO.checked = false; outsel.value = 0
		if lockSel.state do (abs.state = state; abs.changed state)
	)
	on percO changed state do 
	(
		if state == false AND absO.checked == false AND percO.checked == false do percO.state = true
		absO.checked = RelO.checked = false; outsel.value = 100
		if lockSel.state do (perc.state = state; perc.changed state)
	)
	on Rel changed state do
	(
		if state == false AND abs.checked == false AND perc.checked == false do Rel.state = true
		abs.checked = perc.checked = false; insel.value = 0
	)
	on abs changed state do
	(
		if state == false AND Rel.checked == false AND perc.checked == false do abs.state = true
		Rel.checked = perc.checked = false; insel.value = 0
	)
	on perc changed state do 
	(
		if state == false AND abs.checked == false AND perc.checked == false do perc.state = true
		abs.checked = Rel.checked = false; insel.value = 100
	)

	on RelAO changed state do
	(
		if state == false AND absAO.checked == false AND percAO.checked == false do RelAO.state = true
		absAO.checked = percAO.checked = false; outAll.value = 0
		if lockAll.state do (RelA.state = state; RelA.changed state)
	)
	on absAO changed state do
	(
		if state == false AND RelAO.checked == false AND percAO.checked == false do absAO.state = true
		RelAO.checked = percAO.checked = false; outAll.value = 0
		if lockAll.state do (absA.state = state; absA.changed state)
	)
	on percAO changed state do 
	(
		if state == false AND absAO.checked == false AND percAO.checked == false do percAO.state = true
		absAO.checked = RelAO.checked = false; outAll.value = 100
		if lockAll.state do (percA.state = state; percA.changed state)
	)
	on RelA changed state do
	(
		if state == false AND absA.checked == false AND percA.checked == false do RelA.state = true
		absA.checked = percA.checked = false; inall.value = 0
	)
	on absA changed state do
	(
		if state == false AND RelA.checked == false AND percA.checked == false do absA.state = true
		RelA.checked = percA.checked = false; inall.value = 0
	)
	on percA changed state do 
	(
		if state == false AND absA.checked == false AND percA.checked == false do percA.state = true
		absA.checked = RelA.checked = false; inall.value = 100
	)

	on RelSO changed state do
	(
		if state == false AND absSO.checked == false AND percSO.checked == false do RelSO.state = true
		absSO.checked = percSO.checked = false; outns.value = 0
		if lockNS.state do (RelS.state = state; RelS.changed state)
	)
	on absSO changed state do
	(
		if state == false AND RelSO.checked == false AND percSO.checked == false do absSO.state = true
		RelSO.checked = percSO.checked = false; outns.value = 0
		if lockNS.state do (absS.state = state; absS.changed state)
	)
	on percSO changed state do 
	(
		if state == false AND absSO.checked == false AND percSO.checked == false do percSO.state = true
		absSO.checked = RelSO.checked = false; outns.value = 100
		if lockNS.state do (percS.state = state; percS.changed state)
	)
	on RelS changed state do
	(
		if state == false AND absS.checked == false AND percS.checked == false do RelS.state = true
		absS.checked = percS.checked = false; inns.value = 0
	)
	on absS changed state do
	(
		if state == false AND RelS.checked == false AND percS.checked == false do absS.state = true
		RelS.checked = percS.checked = false; inns.value = 0
	)
	on percS changed state do 
	(
		if state == false AND absS.checked == false AND percS.checked == false do percS.state = true
		absS.checked = RelS.checked = false; inns.value = 100
	)
	
	on lockMove changed state do
	(
		insel.enabled = inall.enabled = inns.enabled = not state
		SelLabEnd.enabled= aLabEnd.enabled= nsLabEnd.enabled = not state
	)
	
------------- misc functions


fn rdrw_env = 
(
	disableSceneRedraw() 
local b = #()
	try(
		if dsply.dspselenv.checked then
		(
		for i in 1 to skintoolsenv.bonelst.items.count do
			(
				if skintoolsenv.bonelst.selection[i] then
				( 	
					skinops.setBonePropEnvelopeVisible selection[1].modifiers[skintoolsenv.skin_index] i 1
					if b[1] == undefined then append b i
				)
				else (skinops.setBonePropEnvelopeVisible selection[1].modifiers[skintoolsenv.skin_index] i 0)
			)
	)
	)
	catch(print"error4")
	--else (for i in 1 to skintoolsenv.bonelst.items.count do skinops.setBonePropEnvelopeVisible selection[1].modifiers[skintoolsenv.skin_index] i 0)
	try(skinOps.SelectBone selection[1].modifiers[skintoolsenv.skin_index] b[1])
	catch(print"error5") -- this to select the bone in the skin interface
	enablesceneredraw()
	redrawviews()
)
fn all_enable = -- this to enable all controls if valid
(
try (for ctrl in skintoolsenv.controls where ctrl.name != "lockMove" do ctrl.enabled = true) catch(print"error6")
try (for ctrl in dsply.controls do ctrl.enabled = true) catch(print"error7")
try (for ctrl in lck.controls do ctrl.enabled = true) catch(print"error8")
	if lockMove.state == true and not envOrCrs.state == true do
	(
		insel.enabled = inall.enabled = inns.enabled = false
	)
	rdo1.enabled = envOrCrs.state
)

fn all_disable = -- this to disable all controls if invalid
(
for ctrl in skintoolsenv.controls do
	(
	try (if ctrl !=  getsel then ctrl.enabled = false) catch(print"error9")
	)
try (for ctrl in dsply.controls do ctrl.enabled = false) catch(print"error10")
try (for ctrl in lck.controls do ctrl.enabled = false) catch(print"error11")	
)

------------these to toggle relative/absolute buttons	
fn chnam &input &spinr val =
(
	if val then input = "Absolute"
	else (input = "Relative"; spinr = 0)
)

on envOrCrs changed state do 
(
	rdo1.enabled = envOrCrs.state
	XY.enabled = YZ.enabled = xz.enabled = not envOrCrs.state
	if state then 
	(
		lockMove.enabled = true
		insel.enabled = inall.enabled = inns.enabled = not lockMove.state
		envOrCrs.caption = "Env. Ends"
		abs.visible = rel.visible = perc.visible = \
		absO.visible = relO.visible = percO.visible = \
		absA.visible = relA.visible = percA.visible = \
		absAO.visible = relAO.visible = percAO.visible = \
		absS.visible = relS.visible = percS.visible = \
		absSO.visible = relSO.visible = percSO.visible = false
	Soutsel.visible = Ioutsel.visible = Eoutsel.visible = \
	Sinsel.visible =Iinsel.visible =Einsel.visible = \
	Soutall.visible =Ioutall.visible =Eoutall.visible =	\
 	Sinall.visible =Iinall.visible =Einall.visible = \
	Soutns.visible =Ioutns.visible =Eoutns.visible = \
	Sinns.visible =Iinns.visible =Einns.visible = false
		percM.visible = \
		percOM.visible = \
		percAM.visible = \
		percAOM.visible = \
		percSM.visible = \
		percSOM.visible = true
		
	sLabO.visible =\
	SelLabI.visible =\
	aLabO.visible =\
	aLabI.visible =\
	nsLabO.visible =\
	nsLabI.visible = false
		
	sLabStart.visible =\
	SelLabEnd.visible =\
	aLabStart.visible =\
	aLabEnd.visible =\
	nsLabStart.visible =\
	nsLabEnd.visible = true
	lockSEl.visible =\
	lockALL.visible =\
	lockNS.visible = false
	
	outsel.pos.x += 15
	insel.pos.x += 15
	outall.pos.x += 15
	inall.pos.x += 15
	outns.pos.x += 15
	inns.pos.x += 15
	
		outsel.value = 0
		insel.value = 0
		outall.value = 0
		inall.value = 0
		outns.value = 0
		inns.value = 0
		
	)
	else 
	( 
		lockMove.enabled = false
		insel.enabled = inall.enabled = inns.enabled = true
		envOrCrs.caption = "CrossSections"
		abs.visible = rel.visible = perc.visible = \
		absO.visible = relO.visible = percO.visible = \
		absA.visible = relA.visible = percA.visible = \
		absAO.visible = relAO.visible = percAO.visible = \
		absS.visible = relS.visible = percS.visible = \
		absSO.visible = relSO.visible = percSO.visible = true
	Soutsel.visible = Ioutsel.visible = Eoutsel.visible = \
	Sinsel.visible =Iinsel.visible =Einsel.visible = \
	Soutall.visible =Ioutall.visible =Eoutall.visible =	\
 	Sinall.visible =Iinall.visible =Einall.visible = \
	Soutns.visible =Ioutns.visible =Eoutns.visible = \
	Sinns.visible =Iinns.visible =Einns.visible = true
		percM.visible = \
		percOM.visible = \
		percAM.visible = \
		percAOM.visible = \
		percSM.visible = \
		percSOM.visible = false
	sLabO.visible =\
	SelLabI.visible =\
	aLabO.visible =\
	aLabI.visible =\
	nsLabO.visible =\
	nsLabI.visible = true
	sLabStart.visible =\
	SelLabEnd.visible =\
	aLabStart.visible =\
	aLabEnd.visible =\
	nsLabStart.visible =\
	nsLabEnd.visible = false
	lockSEl.visible =\
	lockALL.visible =\
	lockNS.visible = true
		if percO.state == true then outsel.value = 100 else outsel.value = 0
		if perc.state == true then insel.value = 100 else insel.value = 0
		if percAO.state == true then outall.value = 100 else outall.value = 0
		if percA.state == true then inall.value = 100 else inall.value = 0
		if percSO.state == true then outns.value = 100 else outns.value = 0
		if percS.state == true then inns.value = 100 else inns.value = 0
		
	outsel.pos.x -= 15
	insel.pos.x -= 15
	outall.pos.x -= 15
	inall.pos.x -= 15
	outns.pos.x -= 15
	inns.pos.x -= 15
	locksel.changed lockSel.state
	lockall.changed lockall.state
	lockns.changed lockns.state

	)
)
	
-- function to rebuild the selection and bones lists
fn rebuildselbones relselarr bonesarr selbones =
(
try	(
		skin_index = modPanel.getModifierIndex selection[1] (modpanel.getCurrentObject())
		bonelst.selection = skinops.GetSelectedBone selection[1].modifiers[skin_index] --#{}
		bonesarr = #()
		relselarr = #()
		no_bones = skinops.GetNumberBones selection[1].modifiers[skin_index]
		for i in 1 to no_bones do
		(
			append bonesarr (skinops.GetBoneName selection[1].modifiers[skin_index] i 1)
		)
	
	--building relevant selectionsets here
		for i in 1 to selectionsets.count do
		(
			for j in 1 to selectionsets[i].count do
			(
				for k in 1 to bonesarr.count do
				(
					try(
						if selectionsets[i][j].name == bonesarr[k] do
						( -- I want each item only once so
							if (finditem relselarr (getnamedselsetname i)) == 0 then
							(
								append relselarr (getnamedselsetname i)
							)
		
						)
					)
					catch(print"error12")
				)
			)
		)
		sellst.items = relselarr -- this sets the dropdown  to the relevant items I retrieved
		bonelst.items = bonesarr -- this sets the list of bones
		bonelst.selection = skinops.GetSelectedBone selection[1].modifiers[skin_index]
		append selbones (skinops.GetSelectedBone selection[1].modifiers[skin_index])
		all_enable()
		if envOrCrs.state then
		(
			abs.enabled = rel.enabled = perc.enabled = \
			absO.enabled = relO.enabled = percO.enabled = \
			absA.enabled = relA.enabled = percA.enabled = \
			absAO.enabled = relAO.enabled = percAO.enabled = \
			absS.enabled = relS.enabled = percS.enabled = \
			absSO.enabled = relSO.enabled = percSO.enabled = false
		)
		else
		(
			abs.enabled = rel.enabled = perc.enabled = \
			absO.enabled = relO.enabled = percO.enabled = \
			absA.enabled = relA.enabled = percA.enabled = \
			absAO.enabled = relAO.enabled = percAO.enabled = \
			absS.enabled = relS.enabled = percS.enabled = \
			absSO.enabled = relSO.enabled = percSO.enabled = true
		)
		lockMove.changed (lockMove.state)
		xy.enabled = yz.enabled = xz.enabled = not envOrCrs.state
		lockNS.changed (lockNS.state)
		lockAll.changed (lockAll.state)
		lockSel.changed (lockSel.state)
		STlastSelected = selection[1]
	)
	catch(
	--messagebox "You must have a skin modifier active in the modifier panel, with bones assigned, to use this tool.\nPlease select a Skin modifier/add some bones and hit the Rebuild Selection Sets/Bones button." title:"Skin Tools Error"
	all_disable()
	)
	
)

fn buildBoneAxes = 
(	
	which = rdo1.state
	STboneAxisArray = #()
	STboneAxesArray = #()
	STboneLArray = #()
try(
	for i in 1 to skinops.GetNumberBones selection[1].modifiers[skin_index] do -- find out which axis is most different, chances are this is the length of the bone
	(
		v1 = skinOps.getstartpoint selection[1].modifiers[skin_index] i
		v2 = skinOps.getendpoint selection[1].modifiers[skin_index] i
		v3 = v1 - v2
		v4 = amax v3.x v3.y v3.z
		case which of
		(
			1: (
				if v4 == v3.x then v5 = "x"
				else if v4 == v3.y then v5 = "y" else v5 = "z"
			)
			2:(
				if v4 == v3.x then v5 = "y"
				else if v4 == v3.y then v5 = "z" else v5 = "x"
			)
			3:(
				if v4 == v3.x then v5 = "z"
				else if v4 == v3.y then v5 = "x" else v5 = "y"
			)
		)
		append STboneAxisArray v5
		append STboneAxesArray v3
	)
	local bArray = for i in STboneAxesArray collect length i
	STlongbone = amax barray
)
catch(print"error13")	
)
fn buildSelBoneAxes = 
(	
		STSelboneAxisArray = #()
		STSelboneAxesArray = #()
	which = rdo1.state
try(
--	print "here"
	for i in 1 to selbones.count do -- find out which axis is most different, chances are this is the length of the bone
	(
		v1 = skinOps.getstartpoint selection[1].modifiers[skin_index] selbones[i]
		v2 = skinOps.getendpoint selection[1].modifiers[skin_index] selbones[i]
		v3 = v1 - v2
		v4 = amax v3.x v3.y v3.z
		case which of
		(
			1: (
				if v4 == v3.x then v5 = "x"
				else if v4 == v3.y then v5 = "y" else v5 = "z"
			)
			2:(
				if v4 == v3.x then v5 = "y"
				else if v4 == v3.y then v5 = "z" else v5 = "x"
			)
			3:(
				if v4 == v3.x then v5 = "z"
				else if v4 == v3.y then v5 = "x" else v5 = "y"
			)
		)
		append STSelboneAxisArray v5
		append STSelboneAxesArray v3
	)
	local bArray = for i in STSelboneAxesArray collect length i
	STSellongbone = amax barray
)
catch(print"error14")	
)
fn updateSkinned skin =
(
	try(
	posTemp = skinOps.getendpoint skin 1 
	skinOps.setendpoint skin 1 posTemp
	)catch(print"error15")
)
on rdo1 changed state do
(
buildBoneAxes()
buildSelBoneAxes()
)

--------------- when the rebuild button is pressed
on getsel pressed do
(
rebuildselbones relselarr bonesarr selbones
buildBoneAxes()
buildSelBoneAxes()
)
------------------ modify all of selected bones outer
	on outsel buttonDown do 
	(
		--disablesceneredraw()
		--selection[1].boxmode = true -- my version of the update thing
		if classof (modPanel.getCurrentObject()) != Skin do return(if relO.state == true then outsel.value = 0; if percO.state == true then outsel.value = 100)
		if lockSel.state AND not envOrCrs.state do insel.buttonDown()
		try
		(
			--flagForeground $ true
			origvalOut = #()
			boneCSarr = #()
			ModvalOut = #()
			if selection[1].modifiers[skin_index].draw_vertices == off then (clrvrtstate = 0) else (clrvrtstate = 1)
			if dsply.clrvrt.checked == true then (selection[1].modifiers[skin_index].draw_vertices = off)
		)
		catch(print"error outsel buttonDown")
	)
	on outsel changed val do
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relO.state == true then outsel.value = 0; if percO.state == true then outsel.value = 100)
		--selection[1].modifiers[#skin].draw_vertices = off
		if lockSel.state AND not envOrCrs.state do (insel.value = val; insel.changed val)
		--disablesceneredraw()
		if envOrCrs.state then -- envelope mod
		(		
				updateSkinned selection[1].modifiers[skin_index]
				a = skinops.GetSelectedBone selection[1].modifiers[skin_index]
				bAx = STboneAxisArray[a]
				--print STboneAxisArray #nomap
				--print a
				if bAx == undefined do (buildBoneAxes(); bAx = STboneAxisArray[a])
				if origvalOut[1] == undefined then -- store orig point 3's
				(
					append origvalOut (skinOps.getendpoint selection[1].modifiers[skin_index] a)
					append origvalOut (skinOps.getstartpoint selection[1].modifiers[skin_index] a)
					append modValOut  (skinOps.getendpoint selection[1].modifiers[skin_index] a)
					append modValOut (skinOps.getstartpoint selection[1].modifiers[skin_index] a)
				)
				if percOM.state == true then 
				(
					endval = (val * ((length STboneAxesArray[a])/STlongbone)) as string
				)
				else endval = val as string
				execute ("skintoolsenv.modvalOut[1]." + bAx + "=" + "skintoolsenv.origvalOut[1]." + bAx + " - " + endval)
				skinOps.setendpoint selection[1].modifiers[skin_index] a modvalOut[1] -- end is start
				
				if lockMove.checked == true do
				(
					case rdo1.state of
					(
						1: execute ("skintoolsenv.modvalOut[2]." + bAx + "=" + "skintoolsenv.origvalOut[2]." + bAx + " + " + endval)
						2: execute ("skintoolsenv.modvalOut[2]." + bAx + "=" + "skintoolsenv.origvalOut[2]." + bAx + " - " + endval)
						3: execute ("skintoolsenv.modvalOut[2]." + bAx + "=" + "skintoolsenv.origvalOut[2]." + bAx + " - " + endval)
					)
					skinOps.setstartpoint selection[1].modifiers[skin_index] a modvalOut[2] -- end is start
				)
		)	
		else -- crossection mod
		(	
			try
			(
				a = skinops.GetSelectedBone selection[1].modifiers[skin_index]
				b = skinops.GetNumberCrossSections selection[1].modifiers[skin_index] a
				if origvalOut[1] == undefined then (for i in 1 to b do (append origvalOut (skinOps.getOuterRadius selection[1].modifiers[skin_index] a i)))
				for i in 1 to b do 
				(	
					if Soutsel.state == false AND i == 1 do continue
					if Eoutsel.state == false AND i == b do continue
					if Ioutsel.state == false AND (i!= 1 AND i != b)do continue
					case of
					(
						(relO.state == true):
						(
							if (origvalOut[i] + val) >= 0.0 then
							(	skinOps.setOuterRadius selection[1].modifiers[skin_index] a i (origvalOut[i] + val)
							)
							else
							(	skinOps.setOuterRadius selection[1].modifiers[skin_index] a i (0.0)
							)
						
						)
						(absO.state == true):
						(
							if (val) >= 0.0 then
							(	skinOps.setOuterRadius selection[1].modifiers[skin_index] a i (val)
							)
							else
							(	skinOps.setOuterRadius selection[1].modifiers[skin_index] a i (0.0)
							)
						
						)
						(percO.state = true):
						(
							if (val) >= 0.0 then
							(	skinOps.setOuterRadius selection[1].modifiers[skin_index] a i (origvalOut[i] * val/100.)

							)
							else
							(	skinOps.setOuterRadius selection[1].modifiers[skin_index] a i (0.0)
							)
					
						)
					)
				)
			)	
			catch(print"error16")
		)
		--enablesceneredraw()
		--redrawviews()
	)
on outsel buttonUp do 
	(
		--selection[1].boxmode = false -- my version of the update thing
		if classof (modPanel.getCurrentObject()) != Skin do return(if relO.state == true then outsel.value = 0; if percO.state == true then outsel.value = 100)
		if lockSel.state AND not envOrCrs.state do insel.buttonUp()
		disablesceneredraw()
		ussarr=#()
		
		if envOrCrs.state then -- envelope mod
		(
				updateSkinned selection[1].modifiers[skin_index]
			try
			(
	------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
					append ussarr (skinOps.getendpoint selection[1].modifiers[skin_index] a) -- build current value array
					skinOps.setendpoint selection[1].modifiers[skin_index] a origvalOut[1] -- reset to starting value
	
				undo "Selected Envelope Start Point Change" on
				(
					skinOps.setendpoint selection[1].modifiers[skin_index] a ussarr[1] --then set to new value, which gives us the undo
				)
				ussarr=#()
	------------- end undo info
--				--flagForeground $ false
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error17")
		)
		else -- crossection mod
		(
			try
			(
	------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
			for i in 1 to b do 
				(
					append ussarr (skinOps.getOuterRadius selection[1].modifiers[skin_index] a i) -- build current value array
					skinOps.setOuterRadius selection[1].modifiers[skin_index] a i (origvalOut[i]) -- reset to starting value
				)
	
				undo "Selected Outer Radius Change" on
				(
					for i in 1 to b do 
					(	
						skinOps.setOuterRadius selection[1].modifiers[skin_index] a i ussarr[i] --then set to new value, which gives us the undo
					)
				)
				ussarr=#()
	------------- end undo info
				----flagForeground $ false
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error out buttonup")
		)
		enablesceneredraw()
		redrawviews()
	)
	
on outsel entered do
(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relO.state == true then outsel.value = 0; if percO.state == true then outsel.value = 100)
		if lockSel.state AND not envOrCrs.state do insel.entered()
			
		modvalOut = #()
		origvalOut = #()
	try
	(
		if envOrCrs.state then -- envelope mod
		(	updateSkinned selection[1].modifiers[skin_index]
			 outsel.value = 0
		)
		else
		(
			if (outsel.value == 0 and absO.state == true) then -- this so that if you enter 0 it still changes since there is no changeval
			(
				disablesceneredraw()
				try
				(
					a = skinops.GetSelectedBone selection[1].modifiers[skin_index]
					b = skinops.GetNumberCrossSections selection[1].modifiers[skin_index] a
					for i in 1 to b do (append origvalOut (skinOps.getOuterRadius selection[1].modifiers[skin_index] a i))
					for i in 1 to b do 
					(	
						(	skinOps.setOuterRadius selection[1].modifiers[skin_index] a i (0.0)
						)
					)
				)	
				catch(print"error18")
				enablesceneredraw()
				redrawviews()
			)
			if relO.state == true then outsel.value = 0
			if percO.state == true then outsel.value = 100
		)
	)
	catch(print"error outsel entered")
	)
-----------------------------------------------------------------------------------------
------------------ modify all of selected bones inner
	on insel buttonDown do 
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if rel.state == true then insel.value = 0 ; if perc.state == true then insel.value = 100)
		try
		(
			--flagForeground $ true
			origvalIn = #()
			boneCSarr = #()
			ModvalIn = #()
			if selection[1].modifiers[skin_index].draw_vertices == off then (clrvrtstate = 0) else (clrvrtstate = 1)
			if dsply.clrvrt.checked == true then ( selection[1].modifiers[skin_index].draw_vertices = off)
		)
		catch(print"error insel buttonDown")
	)

	
	on insel changed val do
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if rel.state == true then insel.value = 0 ; if perc.state == true then insel.value = 100)
		--disablesceneredraw()
		if envOrCrs.state then -- envelope mod
		(	
				updateSkinned selection[1].modifiers[skin_index]
				a = skinops.GetSelectedBone selection[1].modifiers[skin_index]
				bAx = STboneAxisArray[a]
				if bAx == undefined do (buildBoneAxes(); bAx = STboneAxisArray[a])
				if origvalIn[1] == undefined then -- store orig point 3's
				(
					append origvalIn (skinOps.getEndpoint selection[1].modifiers[skin_index] a)
					append origvalIn (skinOps.getstartpoint selection[1].modifiers[skin_index] a)
					append modValIn  (skinOps.getEndpoint selection[1].modifiers[skin_index] a)
					append modValIn (skinOps.getstartpoint selection[1].modifiers[skin_index] a)
				)
				if percM.state == true then 
				(
					endval = (val * ((length STboneAxesArray[a])/STlongbone)) as string
				)
				else endval = val as string
				execute ("skintoolsenv.ModvalIn[2]." + bAx + "=" + "skintoolsenv.origvalIn[2]." + bAx + " + " + endval)
				skinOps.setStartpoint selection[1].modifiers[skin_index] a ModvalIn[2]
		)	
		else -- crossection mod
		(	
		if classof (modPanel.getCurrentObject()) != Skin do return()
			try
			(	a = skinops.GetSelectedBone selection[1].modifiers[skin_index]
				b = skinops.GetNumberCrossSections selection[1].modifiers[skin_index] a
				if origvalIn[1] == undefined then (for i in 1 to b do (append origvalIn (skinOps.getInnerRadius selection[1].modifiers[skin_index] a i)))
				for i in 1 to b do 
				(
					if Sinsel.state == false AND i == 1 do continue
					if Iinsel.state == false AND (i!= 1 AND i != b)do continue
					if Einsel.state == false AND i == b do continue
					case of
					(
						(rel.state == true):
						(
							if (origvalIn[i] + val) >= 0.0 then
							(	skinOps.setInnerRadius selection[1].modifiers[skin_index] a i (origvalIn[i] + val)
							)
							else
							(	skinOps.setInnerRadius selection[1].modifiers[skin_index] a i (0.0)
							)
						
						)
						(abs.state == true):
						(
							if (val) >= 0.0 then
							(	skinOps.setInnerRadius selection[1].modifiers[skin_index] a i (val)
							)
							else
							(	skinOps.setInnerRadius selection[1].modifiers[skin_index] a i (0.0)
							)
						
						)
						(perc.state = true):
						(
							if (val) >= 0.0 then
							(	skinOps.setInnerRadius selection[1].modifiers[skin_index] a i (origvalIn[i] * val/100.)

							)
							else
							(	skinOps.setInnerRadius selection[1].modifiers[skin_index] a i (0.0)
							)
					
						)
					)
				)
			)
	
			catch(print"error insel changed val")
		)
	--	enablesceneredraw()
	--	redrawviews()
	)

on insel buttonUp do 
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if rel.state == true then insel.value = 0 ; if perc.state == true then insel.value = 100)
		disablesceneredraw()
		ussarr=#()
		if envOrCrs.state then -- envelope mod
		(
				updateSkinned selection[1].modifiers[skin_index]
			try
			(
	------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
					append ussarr (skinOps.getstartpoint selection[1].modifiers[skin_index] a) -- build current value array
					skinOps.setStartpoint selection[1].modifiers[skin_index] a origvalIn[2] -- reset to starting value
	
				undo "Selected Envelope End Point Change" on
				(
					skinOps.setStartpoint selection[1].modifiers[skin_index] a ussarr[1] --then set to new value, which gives us the undo
				)
				ussarr=#()
	------------- end undo info
				--flagForeground $ false
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error insel in buttonup")
		)
		else -- crossection mod
		(
			try
			(
	------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
			for i in 1 to b do 
				(
					append ussarr (skinOps.getinnerRadius selection[1].modifiers[skin_index] a i) -- build current value array
					skinOps.setinnerRadius selection[1].modifiers[skin_index] a i (origvalIn[i]) -- reset to starting value
				)
	
				undo "Selected Inner Radius Change" on
				(
					for i in 1 to b do 
					(	
						skinOps.setinnerRadius selection[1].modifiers[skin_index] a i ussarr[i] --then set to new value, which gives us the undo
					)
				)
				ussarr=#()
	------------- end undo info
				--flagForeground $ false
				--if AbsRelsel.state != true then insel.value = 0
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error insel in buttonup")
		)
		enablesceneredraw()
		redrawviews()
	)

on insel entered do
	(
	--	return()
		if classof (modPanel.getCurrentObject()) != Skin do return(if rel.state == true then insel.value = 0 ; if perc.state == true then insel.value = 100)
	try
	(
		origvalIn = #()
			boneCSarr = #()
		modvalIn = #()
		if envOrCrs.state then -- envelope mod
		(
				updateSkinned selection[1].modifiers[skin_index]
			 insel.value = 0
		)
		else
		(
			if (insel.value == 0 and abs.state == true) then -- this so that if you enter 0 it still changes since there is no changeval
			(
				disablesceneredraw()
				a = skinops.GetSelectedBone selection[1].modifiers[skin_index]
				b = skinops.GetNumberCrossSections selection[1].modifiers[skin_index] a
				for i in 1 to b do (append origvalIn (skinOps.getInnerRadius selection[1].modifiers[skin_index] a i))
				for i in 1 to b do 
					(	skinOps.setInnerRadius selection[1].modifiers[skin_index] a i (0.0)
					)
				enablesceneredraw()
				redrawviews()
			)
			if rel.state == true then insel.value = 0
			if perc.state == true then insel.value = 100
		)
	)
	catch(print"error insel in entered")
	)

-----------------------------------------------------------------------------------------

------------------ modify all of all  bones outer
	on outall buttonDown do 
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relAO.state == true then outall.value = 0 ; if percAO.state == true then outall.value = 100)
		if lockall.state AND not envOrCrs.state do inall.buttondown()
		try
		(
			--flagForeground $ true
			origvalOut = #()
			origvalOutb = #()
			boneCSarr = #()
			ModvalOut = #()
			if selection[1].modifiers[skin_index].draw_vertices == off then (clrvrtstate = 0) else (clrvrtstate = 1)
			if dsply.clrvrt.checked == true then ( selection[1].modifiers[skin_index].draw_vertices = off)

		)
	catch(print"error outall buttonDown")
	)

	on outall changed val do
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relAO.state == true then outall.value = 0 ; if percAO.state == true then outall.value = 100)
		if lockall.state AND not envOrCrs.state do (inall.value = val; inall.changed val)
	--	disableSceneRedraw() 
		if envOrCrs.state then -- envelope mod
		(	
				--a = skinops.GetSelectedBone selection[1].modifiers[skin_index]
				updateSkinned selection[1].modifiers[skin_index]
				c = skinops.GetNumberBones selection[1].modifiers[skin_index]				
				if origvalOut[1] == undefined then -- store orig point 3's
				(
					for i in 1 to c do
					(
						origvalb = #()
						modvalb = #()
						append origvalb  (skinOps.getendpoint selection[1].modifiers[skin_index] i)
						append origvalb (skinOps.getstartpoint selection[1].modifiers[skin_index] i)
						append modValb  (skinOps.getendpoint selection[1].modifiers[skin_index] i)
						append modValb (skinOps.getstartpoint selection[1].modifiers[skin_index] i)
						append origvalOut origvalb
						append ModvalOut modvalb
					)
				)
				for i in 1 to c do
				(
					bAx = STboneAxisArray[i]
					if bAx == undefined do (buildBoneAxes(); bAx = STboneAxisArray[i])
					if percAOM.state == true then 
					(
						endval = (val * ((length STboneAxesArray[i])/STlongbone)) as string
					)
					else endval = val as string
					execute ("skintoolsenv.ModvalOut[" + i as string + "][1]." + bAx + "=" + "skintoolsenv.origvalOut[" + i as string + "][1]." + bAx + " - " + endval)
					skinOps.setendpoint selection[1].modifiers[skin_index] i ModvalOut[i][1] -- end is start

					if lockMove.checked == true do
					(
						
					case rdo1.state of
					(
						1: execute ("skintoolsenv.ModvalOut[" + i as string + "][2]." + bAx + "=" + "skintoolsenv.origvalOut[" + i as string + "][2]." + bAx + " + " + endval)
						2: execute ("skintoolsenv.ModvalOut[" + i as string + "][2]." + bAx + "=" + "skintoolsenv.origvalOut[" + i as string + "][2]." + bAx + " - " + endval)
						3: execute ("skintoolsenv.ModvalOut[" + i as string + "][2]." + bAx + "=" + "skintoolsenv.origvalOut[" + i as string + "][2]." + bAx + " - " + endval)
					)
						skinOps.setstartpoint selection[1].modifiers[skin_index] i ModvalOut[i][2] -- end is start
					)

				)
		)	
		else -- crossection mod
		(	
			try
				(
					c = skinops.GetNumberBones selection[1].modifiers[skin_index]
					if boneCSarr.count == 0 do 
					(	
						for i in 1 to c do
						(
							append boneCSarr (skinops.GetNumberCrossSections selection[1].modifiers[skin_index] i)
						)
					)
			
					if origValOut[1] == undefined then 
					(
					for i in 1 to c do 
					(
						 origvalOutb = #()
						 for j in 1 to boneCSarr[i] do
						 (
							 append origvalOutb (skinOps.getOuterRadius selection[1].modifiers[skin_index] i j)
						 )
						 append origvalOut origvalOutb 
					 )
					)
		
					for i in 1 to c do
					(
						for j in 1 to boneCSarr[i] do
						(
							if Soutall.state == false AND j == 1 do continue
							if Eoutall.state == false AND j == boneCSarr[i] do continue
							if Ioutall.state == false AND (j!= 1 AND j != boneCSarr[i])do continue
							case of
							(
								(relAO.state == true):
								(
									if (origvalOut[i][j] + val) >= 0.0 then
									(	skinOps.setOuterRadius selection[1].modifiers[skin_index] i j (origvalOut[i][j] + val)
									)
									else
									(	skinOps.setOuterRadius selection[1].modifiers[skin_index] i j (0.0)
									)
								
								)
								(absAO.state == true):
								(
									if (val) >= 0.0 then
									(	skinOps.setOuterRadius selection[1].modifiers[skin_index] i j (val)
									)
									else
									(	skinOps.setOuterRadius selection[1].modifiers[skin_index] i j (0.0)
									)
								
								)
								(percAO.state = true):
								(
									if (val) >= 0.0 then
									(	skinOps.setOuterRadius selection[1].modifiers[skin_index] i j (origvalOut[i][j] * val/100.)
		
									)
									else
									(	skinOps.setOuterRadius selection[1].modifiers[skin_index] i j (0.0)
									)
							
								)
							)
						)
					)
				)
			catch(print"error outall changed val")
		)
	--enablesceneredraw()
	--redrawviews()
	)	

	on outall buttonUp do 
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relAO.state == true then outall.value = 0 ; if percAO.state == true then outall.value = 100)
		if lockall.state AND not envOrCrs.state do inall.buttonup()
		disableSceneRedraw() 
		ussarr=#()
		if envOrCrs.state then -- envelope mod
		(
			updateSkinned selection[1].modifiers[skin_index]
			try
			(
	------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
				for i in 1 to c do
				(
					 ussarr_b=#()
					append ussarr_b (skinOps.getendpoint selection[1].modifiers[skin_index] i) -- build current value array
					append ussarr ussarr_b
				)
				for i in 1 to c do
				(
					skinOps.setendpoint selection[1].modifiers[skin_index] i origvalOut[i][1] -- reset to starting value
				)
	
				undo "All Envelopes Start Point Change" on
				(
					for i in 1 to c do
					(
						skinOps.setendpoint selection[1].modifiers[skin_index] i ussarr[i][1] --then set to new value, which gives us the undo
					)
				)
				ussarr=#()
	------------- end undo info
				--flagForeground $ false
				--if AbsRelselout.state != true then outsel.value = 0
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error outall buttonUp envOrCrs")
		)
		else -- crossection mod
		(
			try
			(
		------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
					for i in 1 to c do -- build current(modified) value array
					(
						 ussarr_b=#()
						 for j in 1 to boneCSarr[i] do
						 (
							 append ussarr_b (skinOps.getOuterRadius selection[1].modifiers[skin_index] i j)
						 )
						 append ussarr ussarr_b
					)
--print boneCSarr.count
					for i in 1 to c do -- reset to starting value
					(
						 for j in 1 to boneCSarr[i] do
						 (
							 skinOps.setOuterRadius selection[1].modifiers[skin_index] i j origvalOut[i][j]
						 )
					)
					undo "All Outer Radius Change" on --then set back to modified value, which gives us the undo
					(
						for i in 1 to c do -- reset to starting value
						(
							for j in 1 to boneCSarr[i] do
							(
								skinOps.setOuterRadius selection[1].modifiers[skin_index] i j ussarr[i][j]
							)
						)
					)
					ussarr=#()
		------------- end undo info
				--flagForeground $ false
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error outall buttonUp")
		)
	enablesceneredraw()
	redrawviews()
	)
	
	on outall entered do
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relAO.state == true then outall.value = 0 ; if percAO.state == true then outall.value = 100)
		if lockall.state AND not envOrCrs.state do inall.entered()
		try
		(
			ModvalOut = #()
			origvalOut = #()
			origvalOutb = #()
			boneCSarr = #()
			if envOrCrs.state then -- envelope mod
			(updateSkinned selection[1].modifiers[skin_index]
			 outall.value = 0
			)
			else
			(
				if (outall.value == 0 and absAO.state == true) then -- this so that if you enter 0 it still changes since there is no changeval
				(
					disableSceneRedraw() 
					c = skinops.GetNumberBones selection[1].modifiers[skin_index]
					if boneCSarr.count == 0 do 
						for i in 1 to c do
						(
						append boneCSarr (skinops.GetNumberCrossSections selection[1].modifiers[skin_index] i)
						)
				
						for i in 1 to c do 
						(
							 origvalOutb = #()
							 for j in 1 to boneCSarr[i] do
							 (
							 append origvalOutb (skinOps.getOuterRadius selection[1].modifiers[skin_index] i j)
							 )
							 append origvalOut origvalOutb
						)
						for i in 1 to c do
						(	for j in 1 to boneCSarr[i] do
							(	skinOps.setOuterRadius selection[1].modifiers[skin_index] i j (0.0)
							)
						)
				enablesceneredraw()
				redrawviews()
				)	
			if relAO.state == true then outall.value = 0
			if percAO.state == true then outall.value = 100
				)
			)
		catch(print"error outall entered")
	)

-----------------------------------------------------------------------------------------

------------------ modify all of all  bones inner
	on inall buttonDown do 
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relA.state == true then inall.value = 0 ; if percA.state == true then inall.value = 100)
		try
		(
			--flagForeground $ true
			origvalIn = #()
			origvalInb = #()
			boneCSarr = #()
			ModvalIn = #()
			if selection[1].modifiers[skin_index].draw_vertices == off then (clrvrtstate = 0) else (clrvrtstate = 1)
			if dsply.clrvrt.checked == true then ( selection[1].modifiers[skin_index].draw_vertices = off)
		)
	catch(print"error inall buttonDown")
	)

	on inall changed val do
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relA.state == true then inall.value = 0 ; if percA.state == true then inall.value = 100)
		--disablesceneredraw()
		if envOrCrs.state then -- envelope mod
		(	
				--a = skinops.GetSelectedBone selection[1].modifiers[skin_index]
				updateSkinned selection[1].modifiers[skin_index]
				c = skinops.GetNumberBones selection[1].modifiers[skin_index]				
				if origvalIn[1] == undefined then -- store orig point 3's
				(
					for i in 1 to c do
					(
						origvalb = #()
						modvalb = #()
						append origvalb  (skinOps.getendpoint selection[1].modifiers[skin_index] i)
						append origvalb (skinOps.getstartpoint selection[1].modifiers[skin_index] i)
						append modValb  (skinOps.getendpoint selection[1].modifiers[skin_index] i)
						append modValb (skinOps.getstartpoint selection[1].modifiers[skin_index] i)
						append origvalIn origvalb
						append modvalIn modvalb
					)
				)
				for i in 1 to c do
				(
					bAx = STboneAxisArray[i]
					if bAx == undefined do (buildBoneAxes(); bAx = STboneAxisArray[i])
					if percAM.state == true then 
					(
						endval = (val * ((length STboneAxesArray[i])/STlongbone)) as string
					)
					else endval = val as string
					execute ("skintoolsenv.ModvalIn[" + i as string + "][2]." + bAx + "=" + "skintoolsenv.origvalIn[" + i as string + "][2]." + bAx + " + " + endval)
					skinOps.setStartpoint selection[1].modifiers[skin_index] i ModvalIn[i][2] -- start is end
				)
		)	
		else -- crossection mod
		(	
			try
			(
				c = skinops.GetNumberBones selection[1].modifiers[skin_index]
				if boneCSarr.count == 0 do 
				(	
					for i in 1 to c do
					(
					append boneCSarr (skinops.GetNumberCrossSections selection[1].modifiers[skin_index] i)
					)
				)
				if origvalIn[1] == undefined then 
				(
					for i in 1 to c do 
					(
						 origvalInb = #()
						 for j in 1 to boneCSarr[i] do
						 (
						 append origvalInb (skinOps.getInnerRadius selection[1].modifiers[skin_index] i j)
						 )
						 append origvalIn origvalInb 
					)
				)
				for i in 1 to c do
				(
					for j in 1 to boneCSarr[i] do
					(
						if Sinall.state == false AND j == 1 do continue
						if Einall.state == false AND j == boneCSarr[i] do continue
						if Iinall.state == false AND (j!= 1 AND j != boneCSarr[i])do continue
						case of
						(
							(relA.state == true):
							(
								if (origvalIn[i][j] + val) >= 0.0 then
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] i j (origvalIn[i][j] + val)
								)
								else
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] i j (0.0)
								)
							
							)
							(absA.state == true):
							(
								if (val) >= 0.0 then
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] i j (val)
								)
								else
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] i j (0.0)
								)
							
							)
							(percA.state = true):
							(
								if (val) >= 0.0 then
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] i j (origvalIn[i][j] * val/100.)
	
								)
								else
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] i j (0.0)
								)
						
							)
						)
					)
				)
			)
		catch(print"error inall changed")
	)
	--enablesceneredraw()
	--redrawviews()
	)	

	on inall buttonUp do 
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relA.state == true then inall.value = 0 ; if percA.state == true then inall.value = 100)
		disableSceneRedraw() 
		ussarr=#()
		if envOrCrs.state then -- envelope mod
		(
				updateSkinned selection[1].modifiers[skin_index]
			try
			(
	------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
				for i in 1 to c do
				(
					 ussarr_b=#()
					append ussarr_b (skinOps.getstartpoint selection[1].modifiers[skin_index] i) -- build current value array
					append ussarr ussarr_b
				)
				for i in 1 to c do
				(
					skinOps.setstartpoint selection[1].modifiers[skin_index] i origvalIn[i][2] -- reset to starting value
				)
	
				undo "All Envelopes End Point Change" on
				(
					for i in 1 to c do
					(
						skinOps.setstartpoint selection[1].modifiers[skin_index] i ussarr[i][1] --then set to new value, which gives us the undo
					)
				)
				ussarr=#()
	------------- end undo info
				--flagForeground $ false
				--if AbsRelselout.state != true then outsel.value = 0
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error inall buttonUp envOrCrs")
		)
		else -- crossection mod
		(
			try
			(
		------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
					for i in 1 to c do -- build current(modified) value array
					(
						 ussarr_b=#()
						 for j in 1 to boneCSarr[i] do
						 (
							 append ussarr_b (skinOps.getinnerRadius selection[1].modifiers[skin_index] i j)
						 )
						 append ussarr ussarr_b
					)
						for i in 1 to c do -- reset to starting value
						(
							 for j in 1 to boneCSarr[i] do
							 (
								 skinOps.setinnerRadius selection[1].modifiers[skin_index] i j origvalIn[i][j]
							 )
						)
					undo "All Inner Radius Change" on --then set back to modified value, which gives us the undo
					(
						for i in 1 to c do -- reset to starting value
						(
							for j in 1 to boneCSarr[i] do
							(
								skinOps.setinnerRadius selection[1].modifiers[skin_index] i j ussarr[i][j]
							)
						)
					)
					ussarr=#()
		------------- end undo info
				--flagForeground $ false
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error inall buttonUp")
		)
		enablesceneredraw()
		redrawviews()
	)
	
	on inall entered do
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relA.state == true then inall.value = 0 ; if percA.state == true then inall.value = 100)
	try
	(
		origvalIn= #()
		origvalInb = #()
		boneCSarr = #()
		modvalIn = #()
		if envOrCrs.state then -- envelope mod
		(
			updateSkinned selection[1].modifiers[skin_index]
			 inall.value = 0
		)
		else
			(
			if (inall.value == 0 and AbsA.state == true) then -- this so that if you enter 0 it still changes since there is no changeval
			(
				disablesceneredraw()
					c = skinops.GetNumberBones selection[1].modifiers[skin_index]
				if boneCSarr.count == 0 do 
					for i in 1 to c do
					(
					append boneCSarr (skinops.GetNumberCrossSections selection[1].modifiers[skin_index] i)
					)
			
					for i in 1 to c do 
					(
						 origvalInb = #()
						 for j in 1 to boneCSarr[i] do
						 (
						 append origvalInb (skinOps.getInnerRadius selection[1].modifiers[skin_index] i j)
						 )
						 append origvalIn origvalInb 
					)
		
					for i in 1 to c do
					(
						for j in 1 to boneCSarr[i] do
						(	skinOps.setInnerRadius selection[1].modifiers[skin_index] i j (0.0)
						)
					)
			enablesceneredraw()
			redrawviews()
			)	
			if relA.state == true then inall.value = 0
			if percA.state == true then inall.value = 100
		)
	)
	catch(print"error inall entered")
	)
	

-------------when an item in the list is selected
on bonelst selectionEnd do 
(
	bone_sel=#()
	selbones = #()
	disableSceneRedraw() 
	--try(
			a = bonelst.selection
			--if (a as array).count == 0 do return()
			--selbones = #()
			for i in 1 to bonelst.items.count do --build array of selected bones
			(
				if bonelst.selection[i] then
				( 	append a i
					bonelst.selection = a
					append selbones i
					if dsply.dspselenv.checked == true then (skinops.setBonePropEnvelopeVisible selection[1].modifiers[skin_index] i 1)
					if bone_sel[1] == undefined then append bone_sel i
					
				)
				else (skinops.setBonePropEnvelopeVisible selection[1].modifiers[skin_index] i 0)
			)
			if bone_sel.count != 0 do
				skinops.selectbone selection[1].modifiers[skin_index] bone_sel[1] -- this matches the first item in the bone list
			buildSelBoneAxes()
	--)
	--catch(print"error")
	enablesceneredraw()
	redrawviews()
)

----- when a selection set is selected:
on sellst selected val do
(
	try
	(	
	disableSceneRedraw() 
		a = bonelst.selection -- these two to clear or not the existing selection
		if clrexst.checked then a = #{}
		for i in 1 to (selectionsets[(sellst.items[val])].count) do
		(
			for j in 1 to bonelst.items.count do
			(
				if selectionsets[(sellst.items[val])][i].name == bonelst.items[j] then
				(
					append a j
					bonelst.selection = a
				)
			)
		)
		selbones = #()
		for i in 1 to bonelst.items.count do --build array of selected bones
		(
			if bonelst.selection[i] then
			(	append selbones i
			)
		)
	rdrw_env()
	enableSceneRedraw() 
	redrawviews()
	)
	catch(print"error sellst selected val")
)

	-------------------------------------------------------------
	---------------------------------outer selected bones in list
	on outns buttonDown do 
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relSO.state == true then outns.value = 0; if percSO.state == true then outns.value = 100)
		if lockns.state AND not envOrCrs.state do inns.buttondown()
		try
		(
			--flagForeground $ true
			origvalOut = #()
			origvalOutb = #()
			boneCSarr = #()
			ModvalOut = #()
			if selection[1].modifiers[skin_index].draw_vertices == off then (clrvrtstate = 0) else (clrvrtstate = 1)
			if dsply.clrvrt.checked == true then ( selection[1].modifiers[skin_index].draw_vertices = off)
			-- rebuild which bones are selected
		)
	catch(print"error outns buttonDown")
	)
	
	on outns changed val do
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relSO.state == true then outns.value = 0; if percSO.state == true then outns.value = 100)
		if lockns.state AND not envOrCrs.state do (inns.value = val; inns.changed val)
		--disableSceneRedraw() 
		if envOrCrs.state then -- envelope mod
		(	
				updateSkinned selection[1].modifiers[skin_index]
				sbc = selbones.count
				if origvalOut[1] == undefined then -- store orig point 3's
				(
					for i in 1 to sbc do
					(
						origvalb = #()
						modvalb = #()
						append origvalb  (skinOps.getendpoint selection[1].modifiers[skin_index] selbones[i])
						append origvalb (skinOps.getstartpoint selection[1].modifiers[skin_index] selbones[i])
						append modValb  (skinOps.getendpoint selection[1].modifiers[skin_index] selbones[i])
						append modValb (skinOps.getstartpoint selection[1].modifiers[skin_index] selbones[i])
						append origvalOut origvalb
						append modvalOut modvalb
					)
				)
				for i in 1 to sbc do
				(
					--bAx = STSelBoneAxisArray[i]
					bAx = STSelBoneAxisArray[i]
					if bAx == undefined do (buildSelBoneAxes(); bAx = STSelboneAxisArray[i])
					if percSOM.state == true then 
					(
						endval = (val * ((length STSelboneAxesArray[i])/STSellongbone)) as string
					)
					else endval = val as string
					execute ("skintoolsenv.modvalOut[" + i as string + "][1]." + bAx + "=" + "skintoolsenv.origvalOut[" + i as string + "][1]." + bAx + " - " + endval)
					skinOps.setendpoint selection[1].modifiers[skin_index] selbones[i] modvalOut[i][1] -- end is start

					if lockMove.checked == true do
					(
						case rdo1.state of
						(
							1: execute ("skintoolsenv.modvalOut[" + i as string + "][2]." + bAx + "=" + "skintoolsenv.origvalOut[" + i as string + "][2]." + bAx + " + " + endval)
							2: execute ("skintoolsenv.modvalOut[" + i as string + "][2]." + bAx + "=" + "skintoolsenv.origvalOut[" + i as string + "][2]." + bAx + " - " + endval)
							3: execute ("skintoolsenv.modvalOut[" + i as string + "][2]." + bAx + "=" + "skintoolsenv.origvalOut[" + i as string + "][2]." + bAx + " - " + endval)
						)
						
						skinOps.setstartpoint selection[1].modifiers[skin_index] selbones[i] modvalOut[i][2] -- end is start
					)
				)
		)	
		else -- crossection mod
		(	
			try
			(
				sbc = selbones.count
				if boneCSarr.count == 0 do 
					for i in 1 to sbc do -- the number of CS in each selected bone
					(
						append boneCSarr (skinops.GetNumberCrossSections selection[1].modifiers[skin_index] selbones[i])
					)
		
				if origvalOut[1] == undefined then 
				(
					for i in 1 to sbc do  -- then store the values of the CS's in each bone
					(
						origvalOutb = #()
						 for j in 1 to boneCSarr[i] do
						 (
							 append origvalOutb (skinOps.getOuterRadius selection[1].modifiers[skin_index] selbones[i] j)
						 )
						 append origvalOut origvalOutb
					)
				)
				for i in 1 to sbc do -- then modify the size of the CS
				(
					for j in 1 to boneCSarr[i] do
					( 
						if Soutns.state == false AND j == 1 do continue
						if Eoutns.state == false AND j == boneCSarr[i] do continue
						if Ioutns.state == false AND (j!= 1 AND j != boneCSarr[i])do continue
						case of
						(
							(relSO.state == true):
							(
								if (origvalOut[i][j] + val) >= 0.0 then
								(	skinOps.setOuterRadius selection[1].modifiers[skin_index] selbones[i] j (origvalOut[i][j] + val)
								)
								else
								(	skinOps.setOuterRadius selection[1].modifiers[skin_index] selbones[i] j (0.0)
								)
							
							)
							(absSO.state == true):
							(
								if (val) >= 0.0 then
								(	skinOps.setOuterRadius selection[1].modifiers[skin_index] selbones[i] j (val)
								)
								else
								(	skinOps.setOuterRadius selection[1].modifiers[skin_index] selbones[i] j (0.0)
								)
							
							)
							(percSO.state = true):
							(
								if (val) >= 0.0 then
								(	skinOps.setOuterRadius selection[1].modifiers[skin_index] selbones[i] j (origvalOut[i][j] * val/100.)
	
								)
								else
								(	skinOps.setOuterRadius selection[1].modifiers[skin_index] selbones[i] j (0.0)
								)
						
							)
						)
					)
				)
			)
			catch(print"error outns changed")
			)
	--enablesceneredraw()
	--redrawviews()
	)	
	on outns buttonUp do 
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relSO.state == true then outns.value = 0; if percSO.state == true then outns.value = 100)
		if lockns.state AND not envOrCrs.state do inns.buttonup()
		disableSceneRedraw() 
		ussarr=#()
		if envOrCrs.state then -- envelope mod
		(
				updateSkinned selection[1].modifiers[skin_index]
			try
			(
	------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
				for i in 1 to sbc do
				(
					 ussarr_b=#()
					append ussarr_b (skinOps.getendpoint selection[1].modifiers[skin_index] selbones[i]) -- build current value array
					append ussarr ussarr_b
				)
				for i in 1 to sbc do
				(
					skinOps.setendpoint selection[1].modifiers[skin_index] selbones[i] origvalOut[i][1] -- reset to starting value
				)
	
				undo "All Envelopes Start Point Change" on
				(
					for i in 1 to sbc do
					(
						skinOps.setendpoint selection[1].modifiers[skin_index] selbones[i] ussarr[i][1] --then set to new value, which gives us the undo
					)
				)
				ussarr=#()
	------------- end undo info
				--flagForeground $ false
				--if AbsRelselout.state != true then outsel.value = 0
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error outns buttonUp envOrCrs")
		)
		else -- crossection mod
		(
			--try
			(
		------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
					for i in 1 to sbc do -- build current(modified) value array
					(
--print boneCSarr #nomap
						 ussarr_b=#()
						 for j in 1 to boneCSarr[i] do
						 (	
						 	--print i
							--print j
							--print skin_index
							 append ussarr_b (skinOps.getOuterRadius selection[1].modifiers[skin_index] i j)
						 )
						 append ussarr ussarr_b
					)
					for i in 1 to sbc do -- reset to starting value
					(
						 for j in 1 to boneCSarr[i] do
						 (
							 skinOps.setOuterRadius selection[1].modifiers[skin_index] i j origvalOut[i][j]
						 )
					)
					undo "Named Selection Outer Radius Change" on --then set back to modified value, which gives us the undo
					(
						for i in 1 to sbc do -- reset to starting value
						(
							for j in 1 to boneCSarr[i] do
							(
								skinOps.setOuterRadius selection[1].modifiers[skin_index] i j ussarr[i][j]
							)
						)
					)
					ussarr=#()
		------------- end undo info
				--flagForeground $ false
				--boneCSarr = #()
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			--catch(print"error outns buttonUp")
		)
	enablesceneredraw()
	redrawviews()
	)
	
	on outns entered do
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relSO.state == true then outns.value = 0; if percSO.state == true then outns.value = 100)
		if lockns.state AND not envOrCrs.state do inns.entered()
	try
	(
		origvalOut = #()
		origvalOutb = #()
		sbc = selbones.count
		modvalOut = #()
			if envOrCrs.state then -- envelope mod
			(
				outns.value = 0
				updateSkinned selection[1].modifiers[skin_index]
			)
			else
			(
				if (outns.value == 0 and AbsSO.state == true) then -- this so that if you enter 0 it still changes since there is no changeval
				(
				disableSceneRedraw() 
				if boneCSarr.count == 0 do 
					for i in 1 to sbc do -- the number of CS in each selected bone
					(
							append boneCSarr (skinops.GetNumberCrossSections selection[1].modifiers[skin_index] selbones[i])
					)
				for i in 1 to sbc do  -- then store the values of the CS's in each bone
				(
					origvalOutb = #()
					 for j in 1 to boneCSarr[i] do
					 (
						 append origvalOutb (skinOps.getOuterRadius selection[1].modifiers[skin_index] selbones[i] j)
					 )
					 append origvalOut origvalOutb
				)
			
				for i in 1 to sbc do -- then modify the size of the CS
				(
					for j in 1 to boneCSarr[i] do
					(	skinOps.setOuterRadius selection[1].modifiers[skin_index]  selbones[i] j (0.0)
					)
				)
				enablesceneredraw()
				redrawviews()
				)	
			if relSO.state == true then outns.value = 0
			if percSO.state == true then outns.value = 100
			)
	)
	catch(print"error outns entere")
	)
	-------------------------------------------------------------
	---------------------------------in named selection
	on inns buttonDown do 
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relS.state == true then inns.value = 0; if percS.state == true then inns.value = 100)
		try
		(
			--flagForeground $ true
			origvalIn = #()
			origvalInb = #()
			boneCSarr = #()
			ModvalIn = #()
			if selection[1].modifiers[skin_index].draw_vertices == off then (clrvrtstate = 0) else (clrvrtstate = 1)
			if dsply.clrvrt.checked == true then ( selection[1].modifiers[skin_index].draw_vertices = off)

		)
	catch(print"error inns buttonDown")
	)
	
	on inns changed val do
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relS.state == true then inns.value = 0; if percS.state == true then inns.value = 100)
--	disableSceneRedraw() 
		if envOrCrs.state then -- envelope mod
		(	
				updateSkinned selection[1].modifiers[skin_index]
				sbc = selbones.count
				if origvalIn[1] == undefined then -- store orig point 3's
				(
					for i in 1 to sbc do
					(
						origvalb = #()
						modvalb = #()
						append origvalb  (skinOps.getendpoint selection[1].modifiers[skin_index] selbones[i])
						append origvalb (skinOps.getstartpoint selection[1].modifiers[skin_index] selbones[i])
						append modValb  (skinOps.getendpoint selection[1].modifiers[skin_index] selbones[i])
						append modValb (skinOps.getstartpoint selection[1].modifiers[skin_index] selbones[i])
						append origvalIn origvalb
						append ModvalIn modvalb
					)
				)
				for i in 1 to sbc do
				(
					bAx = STSelBoneAxisArray[i]
					if bAx == undefined do (buildSelBoneAxes(); bAx = STSelboneAxisArray[i])
					if percSM.state == true then 
					(
						endval = (val * ((length STSelboneAxesArray[i])/STSellongbone)) as string
					)
					else endval = val as string
					--bAx = STSelBoneAxisArray[i]
					execute ("skintoolsenv.ModvalIn[" + i as string + "][2]." + bAx + "=" + "skintoolsenv.origvalIn[" + i as string + "][2]." + bAx + " + " + endval)
					skinOps.setstartpoint selection[1].modifiers[skin_index] selbones[i] ModvalIn[i][2] -- end is start
				)
		)	
		else -- crossection mod
		(	
		try
			(
				sbc = selbones.count
				if boneCSarr.count == 0 do 
					for i in 1 to sbc do -- the number of CS in each selected bone
					(
						append boneCSarr (skinops.GetNumberCrossSections selection[1].modifiers[skin_index] selbones[i])
					)
	
				if origvalIn[1] == undefined then 
				(
					for i in 1 to sbc do  -- then store the values of the CS's in each bone
					(
						origvalInb = #()
						 for j in 1 to boneCSarr[i] do
						 (
							 append origvalInb (skinOps.getInnerRadius selection[1].modifiers[skin_index] selbones[i] j)
						 )
						 append origvalIn origvalInb
					)
				)
				for i in 1 to sbc do -- then modify the size of the CS
				(
					for j in 1 to boneCSarr[i] do
					(
						if Sinns.state == false AND j == 1 do continue
						if Einns.state == false AND j == boneCSarr[i] do continue
						if Iinns.state == false AND (j!= 1 AND j != boneCSarr[i])do continue
						case of
						(
							(relSO.state == true):
							(
								if (origvalIn[i][j] + val) >= 0.0 then
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] selbones[i] j (origvalIn[i][j] + val)
								)
								else
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] selbones[i] j (0.0)
								)
							
							)
							(absSO.state == true):
							(
								if (val) >= 0.0 then
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] selbones[i] j (val)
								)
								else
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] selbones[i] j (0.0)
								)
							
							)
							(percSO.state = true):
							(
								if (val) >= 0.0 then
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] selbones[i] j (origvalIn[i][j] * val/100.)
	
								)
								else
								(	skinOps.setInnerRadius selection[1].modifiers[skin_index] selbones[i] j (0.0)
								)
						
							)
						)
					)
				)
			)
		catch(print"error inns changed val")
		)
--	enablesceneredraw()
--	redrawviews()
	)	
	on inns buttonUp do 
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relS.state == true then inns.value = 0; if percS.state == true then inns.value = 100)
		disableSceneRedraw() 
		ussarr=#()
		if envOrCrs.state then -- envelope mod
		(
			updateSkinned selection[1].modifiers[skin_index]
			try
			(
	------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
				for i in 1 to sbc do
				(
					 ussarr_b=#()
					append ussarr_b (skinOps.getstartpoint selection[1].modifiers[skin_index] selbones[i]) -- build current value array
					append ussarr ussarr_b
				)
				for i in 1 to sbc do
				(
					skinOps.setstartpoint selection[1].modifiers[skin_index] selbones[i] origvalIn[i][2] -- reset to starting value
				)
	
				undo "NS Envelopes End Point Change" on
				(
					for i in 1 to sbc do
					(
						skinOps.setstartpoint selection[1].modifiers[skin_index] selbones[i] ussarr[i][1] --then set to new value, which gives us the undo
					)
				)
				ussarr=#()
	------------- end undo info
				--flagForeground $ false
				--if AbsRelselout.state != true then outsel.value = 0
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error inns buttonUp envOrCrs")
		)
		else -- crossection mod
		(
			try
			(
		------------- undo starts here - there have been lots of val changes and we want one, so I undo all ops then reapply
					for i in 1 to sbc do -- build current(modified) value array
					(
						 ussarr_b=#()
						 for j in 1 to boneCSarr[i] do
						 (
							 append ussarr_b (skinOps.getInnerRadius selection[1].modifiers[skin_index] i j)
						 )
						 append ussarr ussarr_b
					)
					for i in 1 to sbc do -- reset to starting value
					(
						 for j in 1 to boneCSarr[i] do
						 (
							 skinOps.setInnerRadius selection[1].modifiers[skin_index] i j origvalIn[i][j]
						 )
					)
					undo "Named Selection Inner Radius Change" on --then set back to modified value, which gives us the undo
					(
						for i in 1 to sbc do -- reset to starting value
						(
							for j in 1 to boneCSarr[i] do
							(
								skinOps.setInnerRadius selection[1].modifiers[skin_index] i j ussarr[i][j]
							)
						)
					)
					ussarr=#()
		------------- end undo info
				--flagForeground $ false
				--boneCSarr = #()
				if clrvrtstate == 1 then selection[1].modifiers[skin_index].draw_vertices = on
			)
			catch(print"error inns buttonUp")
			)
	enablesceneredraw()
	redrawviews()
	)
	
	on inns entered do
	(
		if classof (modPanel.getCurrentObject()) != Skin do return(if relS.state == true then inns.value = 0; if percS.state == true then inns.value = 100)
	try
	(	
		origvalIn = #()
		origvalInb = #()
		sbc = selbones.count
		modvalIn = #()
			if envOrCrs.state then -- envelope mod
			(
				 inns.value = 0
				updateSkinned selection[1].modifiers[skin_index]
			)
			else
			(
				if (inns.value == 0 and absS.state == true) then -- this so that if you enter 0 it still changes since there is no changeval
				(
				disableSceneRedraw() 
						if boneCSarr.count == 0 do 
							for i in 1 to sbc do -- the number of CS in each selected bone
							(
									append boneCSarr (skinops.GetNumberCrossSections selection[1].modifiers[skin_index] selbones[i])
							)
			
						for i in 1 to sbc do  -- then store the values of the CS's in each bone
						(
							origvalInb = #()
							 for j in 1 to boneCSarr[i] do
							 (
								 append origvalInb (skinOps.getInnerRadius selection[1].modifiers[skin_index] selbones[i] j)
							 )
							 append origvalIn origvalInb
						)
			
						for i in 1 to sbc do -- then modify the size of the CS
						(
							for j in 1 to boneCSarr[i] do
							(	skinOps.setInnerRadius selection[1].modifiers[skin_index]  selbones[i] j (0.0)
							)
						)
				enablesceneredraw()
				redrawviews()
				)	
			if relS.state == true then inns.value = 0
			if percS.state == true then inns.value = 100
			)
	)
	catch(print"error inns entered")
	)


---------------- reverse bone

fn revBone = 
(	if skintoolsenv.skin_index == undefined do return()
	undo "Reverse Bone" on
	(
		disablesceneredraw()
		try
		(
			origval = #()
			origval_rev = #()
			a = skinops.GetSelectedBone selection[1].modifiers[skin_index]
			b = skinops.GetNumberCrossSections selection[1].modifiers[skin_index] a
			for i in 1 to b do (append origval (skinOps.getOuterRadius selection[1].modifiers[skin_index] a i))
			for i in 1 to b do
			(
				append origval_rev origval[b - (i-1)]
			)
			for i in 1 to b do 
			(
				skinOps.setOuterRadius selection[1].modifiers[skin_index] a i (origval_rev[i])
			)
			origval = #()
			origval_rev = #()
			for i in 1 to b do (append origval (skinOps.getInnerRadius selection[1].modifiers[skin_index] a i))
			for i in 1 to b do
			(
				append origval_rev origval[b - (i-1)]
			)
			for i in 1 to b do 
			(
				skinOps.setInnerRadius selection[1].modifiers[skin_index] a i (origval_rev[i])
			)
		)
		catch()
		enablesceneredraw()
		redrawviews()
	)
)
fn remMult =
(	if skintoolsenv.skin_index == undefined do return()
	try(
	undo "MultiRemove Bones" on (skinops.multiRemove selection[1].modifiers[skintoolsenv.skin_index])
	)catch()
)

on skintoolsenv open do --this simply fills in the bones and selection sets dropdown
(	
	disablesceneredraw()
	try	(
		if (skin_index = modPanel.getModifierIndex selection[1] (modpanel.getCurrentObject())) != undefined then
		(	rebuildselbones relselarr bonesarr selbones
			for i in 1 to bonelst.items.count do -- this resets the bone visibility
			(
				if bonelst.selection[i] then
				( 	
					skinops.setBonePropEnvelopeVisible selection[1].modifiers[skin_index] i 1
				)
				else (skinops.setBonePropEnvelopeVisible selection[1].modifiers[skin_index] i 0)
			)
			buildBoneAxes()
			buildSelBoneAxes()

		)
		else 
		(
		all_disable()
	--	messagebox "You must have a skin modifier active in the modifier panel to use this tool.\nPlease select a Skin modifier and hit the Rebuild Selection Sets/Bones button." title:"Skin Tools Error"
		)
	)

	catch
	(
	--messagebox "You must have a skin modifier active in the modifier panel to use this tool.\nPlease select a Skin modifier and hit the Rebuild Selection Sets/Bones button." title:"Skin Tools Error"		
	all_disable()
	enablesceneredraw()
	redrawviews()
	)

	st_opened = true
	enablesceneredraw()
	redrawviews()
)

on skintoolsenv close do --this simply fills in the bones and selection sets dropdown
(	disablesceneredraw()
	try
	(		for i in 1 to bonelst.items.count do -- this resets the bone visibility
			(
				skinops.setBonePropEnvelopeVisible selection[1].modifiers[skin_index] i 0
			)

		)
	
	catch(enablesceneredraw(); redrawviews() )
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "Pos" ((getdialogpos subroll) as string)
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "Y" (subroll.height as string)
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "X" (subroll.width as string)
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "scrollpos" (subroll.stsubroll.skintoolsenv.scrollpos as string)
	
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelOuter" (if relO.state then "1" else if absO.state then "2" else "3")
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelInner" (if rel.state then "1" else if abs.state then "2" else "3")

	setinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelOuterA" (if relAO.state then "1" else if absAO.state then "2" else "3")
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelInnerA" (if relA.state then "1" else if absA.state then "2" else "3")

	setinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelOuterS" (if relSO.state then "1" else if absSO.state then "2" else "3")
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelInnerS" (if relS.state then "1" else if absS.state then "2" else "3")


	setinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelOuter" (percOM.state as string)
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelInner" (percM.state as string)
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelOuterA" (percAOM.state as string)
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelInnerA" (percAM.state as string)
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelOuterS" (percSOM.state as string)
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelInnerS" (percSM.state as string)
	
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "lockSel" (lockSel.state as string)
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "lockAll" (lockAll.state as string)
	setinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "lockNS" (lockNS.state as string)
	
	enablesceneredraw()
	redrawviews()
	st_opened = false
)

)-- end rollout skintoolsenv


rollout dsply "Display"
(
	group "Interactivity/Display"
	(
	checkbox clrvrt "No Colored Verts Interactively"
	checkbox dspselenv "Display All Selected Env." checked:true
	button tggall "Toggle Display All Envelopes" width:159 height:20
	button tggenvtop "Toggle Envelopes On Top" width:159 height:20
	button tggcrstop "Toggle Cross Sec. On Top" width:159 height:20
	button tggclrvrt "Toggle Display Color Verts" width:159 height:20
	button tggshad "Toggle Shaded Weights" width:159 height:20
	button ztb "Zoom To Selected Bone" width:159 height:20
	)
	-------------------this to turn off env display of existing displayed envelopes
on dspselenv changed state do
(
	if state == false then 
	(
		disablesceneredraw()
		for i in 1 to skintoolsenv.bonelst.items.count do 
			(
					skinops.setBonePropEnvelopeVisible selection[1].modifiers[skintoolsenv.skin_index] i 0
			)
		enablesceneredraw()
		redrawviews()
	)
	else
	(
	disableSceneRedraw() 
	try(
			for i in 1 to skintoolsenv.bonelst.items.count do
			(
				if skintoolsenv.bonelst.selection[i] then
				( 	
					skinops.setBonePropEnvelopeVisible selection[1].modifiers[skintoolsenv.skin_index] i 1
				)
			)
	)
	catch(print"error19")
	enablesceneredraw()
	redrawviews()
	)
)
	
	
-------------- this to toggle display all envelopes	
on tggall pressed do
(
try
(
	if selection[1].modifiers[skintoolsenv.skin_index].draw_all_envelopes then (selection[1].modifiers[skintoolsenv.skin_index].draw_all_envelopes = false)
	else (selection[1].modifiers[skintoolsenv.skin_index].draw_all_envelopes = true)
)
catch(print"error20")
)
-------------- this to toggle display clr verts	
on tggclrvrt pressed do
(
try
(
	if selection[1].modifiers[skintoolsenv.skin_index].draw_vertices == on then (selection[1].modifiers[skintoolsenv.skin_index].draw_vertices = off)
	else (selection[1].modifiers[skintoolsenv.skin_index].draw_vertices = on)
)
catch(print"error21")
)
-------------- this to toggle display shaded mesh	
on tggshad pressed do
(
try
(
	if selection[1].modifiers[skintoolsenv.skin_index].shadeweights == on then (selection[1].modifiers[skintoolsenv.skin_index].shadeweights = off)
	else (selection[1].modifiers[skintoolsenv.skin_index].shadeweights = on)
)
catch(print"error22")
)
-------------- this to toggle display envelopes on top	
on tggenvtop pressed do
(
try
(
	if selection[1].modifiers[skintoolsenv.skin_index].envelopesAlwaysOnTop== on then (selection[1].modifiers[skintoolsenv.skin_index].envelopesAlwaysOnTop= off)
	else (selection[1].modifiers[skintoolsenv.skin_index].envelopesAlwaysOnTop= on)
)
catch(print"error23")
)
-------------- this to toggle display crosssections on top	
on tggcrstop pressed do
(
try
(
	if selection[1].modifiers[skintoolsenv.skin_index].crossSectionsAlwaysOnTop == on then (selection[1].modifiers[skintoolsenv.skin_index].crossSectionsAlwaysOnTop= off)
	else (selection[1].modifiers[skintoolsenv.skin_index].crossSectionsAlwaysOnTop= on)
)
catch(print"error24")
)
on ztb pressed do
(
	skinops.zoomToBone selection[1].modifiers[skintoolsenv.skin_index] false
)


) --end rollout dsply
rollout aply "Skin Operations" width:162 height:100
(
	button applySkin "Apply Skin to Selected" pos:[10,7] width:160 height:21
	checkbox setInit "Set Initial Envelope Values:" pos:[10,36] width:165 height:16 checked:true
	spinner initialInnerEnvelopePercent "Inner" pos:[18,62] width:62 height:16 range:[0,100000,0.2] fieldwidth:40
	spinner initialOuterEnvelopePercent "Outer" pos:[106,62] width:64 height:16 range:[0,100000,8] fieldwidth:40
	on applySkin pressed do
	(
		local a = skin()
		if setInit.checked do
		(
			a.initialInnerEnvelopePercent = initialInnerEnvelopePercent.value
			a.initialOuterEnvelopePercent = initialOuterEnvelopePercent.value
		)
		for i in selection do addmodifier i a
		
	--	skintoolsenv.rebuildselbones relselarr bonesarr selbones
	--	skintoolsenv.buildBoneAxes()
	--	skintoolsenv.buildSelBoneAxes()

	)
	
	on saveData pressed do
	(
	--fn get_weights_bones =
--	(
		local weight_array = #()
		for i in 1 to numvrt do
			(
				for j in 1 to skinOps.getNumberBones selection[1].modifiers[skin_index] do
				(
					tmp_weight_array = #()
					tmp_bone_array = #()
					try(
						if (skinOps.GetVertexWeight selection[1].modifiers[skin_index] i j) != undefined then
							(
							append tmp_weight_array (skinOps.GetVertexWeight selection[1].modifiers[skin_index] i j)
							append tmp_bone_array (skinOps.GetVertexWeight selection[1].modifiers[skin_index] i j)
							)
						)
					catch(append tmp_weight_array "z")
				)
				append weight_array tmp_weight_array
			)
		print weight_array
--	)
	/*
	GetVertexWeightBoneID 
skinOps.GetVertexWeight $.modifiers[1] 1 1
skinOps.GetVertexWeightBoneID $.modifiers[1] 200 1
skinOps.getbonename $.modifiers[1] 8 0

*/
	)
	

)
rollout lck "Bake vertex weights"
(
	local skin_index
	local numvrt
	local tmp_weight_array
	local weight_array
	local sel_arr
	
	fn prep_skin = 
	(
		try
		( 
			skin_index = modPanel.getModifierIndex selection[1] (modpanel.getCurrentObject())
			numvrt = (skinOps.GetNumberVertices selection[1].modifiers[skin_index])
		)
		catch(messagebox "Need to have a skin selected in the modify panel")
	)

	fn get_weights =
	(	local weight_array = #()
		for i in 1 to numvrt do
			(
				for j in 1 to skinOps.getNumberBones selection[1].modifiers[skin_index] do
				(
					try
						(
						if (skinOps.GetVertexWeight selection[1].modifiers[skin_index] i j) != undefined then
							(
							append tmp_weight_array (skinOps.GetVertexWeight selection[1].modifiers[skin_index] i j)
							)
					)
					catch(append tmp_weight_array "z")
				)
				append weight_array tmp_weight_array
				tmp_weight_array = #()
			)
		return weight_array
	)
	fn get_weights_sel =
	(	for i in 1 to numvrt do
			(
				if (skinOps.isVertexSelected selection[1].modifiers[skin_index] i == 1) then
				(
					append sel_arr i
					for j in 1 to skinOps.getNumberBones selection[1].modifiers[skin_index] do
					(
						try
							(
							if (skinOps.GetVertexWeight selection[1].modifiers[skin_index] i j) != undefined then
								(
								append tmp_weight_array (skinOps.GetVertexWeight selection[1].modifiers[skin_index] i j)
								)
						)
						catch(append tmp_weight_array "z")
					)
					append weight_array tmp_weight_array
					tmp_weight_array = #()
				)
			)
	)

	button lavw "Bake All Vertex Weights" width:160 offset:[-3,0]
	button lsvw "Bake Selected Vertex Weights" width:160 offset:[-2,0]
	button rstall "Reset All Vertex Weights" width:160 offset:[-3,0]
	button rstsel "Reset Selected Vertex Weights" width:160 offset:[-0,0]
	
	on lavw pressed do
	(
		disableSceneRedraw()
			prep_skin()
		-- find which are selected
			sel_arr = #()
			-- now I store the currently selected vertices
			for i in 1 to numvrt do
			(
				if (skinOps.isVertexSelected selection[1].modifiers[skin_index] i == 1) then
				(	
					append sel_arr i
				)
			)
		-- select all verts
			skinOps.SelectVertices selection[1].modifiers[skin_index] #{1..numvrt}
	skinOps.bakeSelectedVerts selection[1].modifiers[skin_index]
	-- then reset the selection
			skinOps.SelectVertices selection[1].modifiers[skin_index] sel_arr

	enablesceneredraw()
	redrawviews()
	)

	on lsvw  pressed do
	(
	
		disableSceneRedraw() 
		prep_skin()			
	skinOps.bakeSelectedVerts selection[1].modifiers[skin_index]

		enablesceneredraw()
		redrawviews()
		
	)
	on rstall pressed do
	(
		disableSceneRedraw() 
		try
		(	
			prep_skin()			
			sel_arr = #()
			all_vert_array = #()
			-- now I store the currently selected vertices
			for i in 1 to numvrt do
			(
				if (skinOps.isVertexSelected selection[1].modifiers[skin_index] i == 1) then
				(	
					append sel_arr i
				)
			)
			
			-- select all vertices via bitarray then reset them
			skinOps.SelectVertices selection[1].modifiers[skin_index] #{1..numvrt}
			skinOps.resetSelectedVerts selection[1].modifiers[skin_index]
			-- then retrieve original selection, the enable/redraw views is needed here else fails
			enablesceneredraw()
			redrawviews()
			skinOps.SelectVertices selection[1].modifiers[skin_index] sel_arr
		)
		catch(print"error25")
		enablesceneredraw()
		--redrawviews()
	)
	
	on rstsel pressed do
	(
		try
		(
			prep_skin()			
			skinOps.resetSelectedVerts selection[1].modifiers[skin_index]
		)
		catch(print"error26")
		)
)
rollout subRoll "Skin Tools: Envelopes 2.0"
(
	subrollout stsubroll pos:[4,4] width:200 height:600
	
	on subroll open do
	(
		addsubrollout stsubroll skintoolsenv
		addsubrollout stsubroll dsply rolledup:true
		addsubrollout stsubroll lck rolledup:true
		addsubrollout stsubroll aply rolledup:true
		inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "scrollpos")
		if inval != OK then skintoolsenv.scrollpos = inval
		stsubroll.height = subRoll.height - 2
	-- set the UI buttons:
		inval = getinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelInner"
		case inval of
		(
			default:()
			"1": (skintoolsenv.rel.checked = true; skintoolsenv.rel.changed true)
			"2": (skintoolsenv.abs.checked = true; skintoolsenv.abs.changed true)
			"3": (skintoolsenv.perc.checked = true; skintoolsenv.perc.changed true)
		)
		inval = getinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelOuter"
		case inval of
		(
			default:()
			"1": (skintoolsenv.relO.checked = true; skintoolsenv.relO.changed true)
			"2": (skintoolsenv.absO.checked = true; skintoolsenv.absO.changed true)
			"3": (skintoolsenv.percO.checked = true; skintoolsenv.percO.changed true)
		)

		inval = getinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelInnerA"
		case inval of
		(
			default:()
			"1": (skintoolsenv.relA.checked = true; skintoolsenv.relA.changed true)
			"2": (skintoolsenv.absA.checked = true; skintoolsenv.absA.changed true)
			"3": (skintoolsenv.percA.checked = true; skintoolsenv.percA.changed true)
		)
		inval = getinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelOuterA"
		case inval of
		(
			default:()
			"1": (skintoolsenv.relAO.checked = true; skintoolsenv.relAO.changed true)
			"2": (skintoolsenv.absAO.checked = true; skintoolsenv.absAO.changed true)
			"3": (skintoolsenv.percAO.checked = true; skintoolsenv.percAO.changed true)
		)

		inval = getinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelInnerS"
		case inval of
		(
			default:()
			"1": (skintoolsenv.relS.checked = true; skintoolsenv.relS.changed true)
			"2": (skintoolsenv.absS.checked = true; skintoolsenv.absS.changed true)
			"3": (skintoolsenv.percS.checked = true; skintoolsenv.percS.changed true)
		)
		inval = getinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "SelOuterS"
		case inval of
		(
			default:()
			"1": (skintoolsenv.relSO.checked = true; skintoolsenv.relSO.changed true)
			"2": (skintoolsenv.absSO.checked = true; skintoolsenv.absSO.changed true)
			"3": (skintoolsenv.percSO.checked = true; skintoolsenv.percSO.changed true)
		)
		
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "lockSel")
	if inval != OK do (skintoolsenv.lockSel.state = inval; skintoolsenv.lockSel.changed inval)
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "lockAll")
	if inval != OK do (skintoolsenv.lockAll.state = inval; skintoolsenv.lockall.changed inval)
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "Buttons" "lockNS")
	if inval != OK do (skintoolsenv.lockNS.state = inval; skintoolsenv.lockns.changed inval)
	

	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelOuter" )
	if inval != OK do skintoolsenv.percOM.state = inval
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelInner")
	if inval != OK do skintoolsenv.percM.state = inval
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelOuterA") 
	if inval != OK do skintoolsenv.percAOM.state = inval
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelInnerA")
	if inval != OK do skintoolsenv.percAM.state = inval
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelOuterS")
	if inval != OK do skintoolsenv.percSOM.state = inval
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "movePerc" "SelInnerS")
	if inval != OK do skintoolsenv.percSM.state = inval
	--callbacks.removescripts id:#skinTools_cb
	--callbacks.addscript #modPanelSelChanged "skintoolsenv.getsel.pressed()" id:#skinTools_cb
	--callbacks.addscript #modPanelObjPostChange "skintoolsenv.getsel.pressed()" id:#skinTools_cb
	)
	on subRoll resized val do
	(
		try(
		stsubroll.height = val.y - 2
		subRoll.width = 205
		)catch(print"error27")
	)
	on subroll close do
	(
		callbacks.removescripts id:#skinTools_cb
	)
)
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "Pos")
	if inval != OK then startPos = inval else startpos = [200,200]
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "Y")
	if inval != OK then startY = inval else startY = 600
	inval = execute (getinisetting (scriptsPath + "SkinToolsEnv.ini") "UI" "X")
	if inval != OK then startX = inval else startX = 205
	if startpos.x < 0 do startpos = [100,100]
createdialog subroll startX startY pos:startPos style:#(#style_titlebar, #style_border, #style_sysmenu,  #style_resizing) menu:stmenu 

)-- end macroscript
